{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Action Dialog Unit                                                }
{                                                                             }
{ 2001-05 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Actdlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnList, ComCtrls, ToolWin, ExtCtrls, Menus, EnhListView,
  ExtListView, ZonuAction, ZonuClass, ImgList, Main, StdCtrls, ZonuSplitter;

type
  TActionDialog = class(TForm)
    ActionList1: TActionList;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    StatusBar1: TStatusBar;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    Panel2: TPanel;
    Splitter2: TSplitter;
    ImageList1: TImageList;
    Panel4: TPanel;
    TreeView1: TTreeView;
    Panel5: TPanel;
    ComboBox1: TComboBox;
    Panel6: TPanel;
    CheckBox1: TCheckBox;
    dfsExtListView4: TdfsExtListView;
    actAdd: TAction;
    actEdit: TAction;
    actDelete: TAction;
    ImageList2: TImageList;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    Edit1: TMenuItem;
    N2: TMenuItem;
    Delete1: TMenuItem;
    TabControl1: TTabControl;
    Panel1: TPanel;
    ZonuSplitter1: TZonuSplitter;
    dfsExtListView1: TdfsExtListView;
    Panel3: TPanel;
    Splitter3: TSplitter;
    dfsExtListView2: TdfsExtListView;
    dfsExtListView3: TdfsExtListView;
    actRefresh: TAction;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    actAddBatch: TAction;
    ToolButton7: TToolButton;
    procedure dfsExtListView1Change(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure CheckBox1Click(Sender: TObject);
    procedure actAddExecute(Sender: TObject);
    procedure actEditExecute(Sender: TObject);
    procedure actDeleteExecute(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TabControl1Change(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure actRefreshExecute(Sender: TObject);
    procedure actAddBatchExecute(Sender: TObject);
  private
    { Private 錾 }
    FResActionList: TZonuActionList;
    FThreadActionList: TZonuActionList;
    FSaveHeight: integer;
    procedure BuildActionList(ActionList: TZonuActionList);
    procedure BuildBoardList;
    function  AddActionItem(ActionItem: TZonuAction; ListView: TdfsExtListView): TListItem;
    procedure SaveActions;
  public
    { Public 錾 }
    procedure InitRes(ActionList: TZonuActionList);
    procedure InitThread(ActionList: TZonuActionList);
    procedure Init;
  end;

  PNodeData = ^TNodeData;
  TNodeData = record
    SiteID    : string;
    BoardID   : string;
    Name      : string;
    Url       : string;
    IsAll     : boolean;
  end;

var
  ActionDialog: TActionDialog;

implementation

{$R *.dfm}

uses
  ZonuConf, Hzbconst, Hzbclass, Actdlg2, Hzbfunc, Ngworddlg;

{ TActionDialog }

procedure TActionDialog.FormCreate(Sender: TObject);
begin
  ActionDialog2 :=  nil;
  PageControl1.ActivePageIndex  :=  0;
  FSaveHeight                   :=  Height;
end;

procedure TActionDialog.FormDestroy(Sender: TObject);
var
  i:  integer;
  p:  PNodeData;
begin
  dfsExtListView1.Items.Clear;
  dfsExtListView2.Items.Clear;
  dfsExtListView3.Items.Clear;
  for i :=  TreeView1.Items.Count - 1 downto  0 do  begin
    if  (TreeView1.Items[i].Data <> nil)  then  begin
      p :=  PNodeData(TreeView1.Items[i].Data);
      Dispose(p);
    end;
  end;
  if  (ActionDialog2 <> nil)  then  ActionDialog2.Release;
end;

procedure TActionDialog.InitRes(ActionList: TZonuActionList);
begin
  FResActionList :=  ActionList;
end;

procedure TActionDialog.InitThread(ActionList: TZonuActionList);
begin
  FThreadActionList :=  ActionList;
end;

procedure TActionDialog.BuildActionList(ActionList: TZonuActionList);
var
  i: integer;
begin
  dfsExtListView1.OnChange  :=  nil;
  dfsExtListView1.Items.BeginUpdate;
  try
    dfsExtListView1.Items.Clear;
    for i :=  0 to  ActionList.Count - 1 do  begin
      AddActionItem(ActionList[i], dfsExtListView1);
    end;
    dfsExtListView1.OnChange  :=  dfsExtListView1Change;
  finally
    dfsExtListView1.Items.EndUpdate;
  end;
end;

procedure TActionDialog.BuildBoardList;
  procedure _BuildBoardList(Site: TSite; BoardName: string; BoardList: TBoardList);
  var
    NGWord1,  NGWord2 : TStringList;
    ParentNode, CategoryNode, Node: TTreeNode;
    NodeData : PNodeData;
    CategoryName : string;
    i : integer;
  begin
    NGWord1   :=  TStringList.Create;
    if  (FileExists(ZonuConfig.UsersPath + FILE_RES_ACTION)) then  begin
      NGWord1.LoadFromFile(ZonuConfig.UsersPath + FILE_RES_ACTION);
    end;
    NGWord2   :=  TStringList.Create;
    if  (FileExists(ZonuConfig.UsersPath + FILE_RES_ACTION)) then  begin
      NGWord2.LoadFromFile(ZonuConfig.UsersPath + FILE_RES_ACTION);
    end;
    ParentNode      :=  TreeView1.Items.AddChild(nil , BoardName);
    ParentNode.ImageIndex     :=  Site.ImageIndex;
    ParentNode.SelectedIndex  :=  Site.ImageIndex;
    ParentNode.Data :=  nil;
    CategoryNode    :=  ParentNode;
    CategoryName    :=  '';
    for i :=  0 to  BoardList.Count - 1 do  begin
      if  (CategoryName <> BoardList[i].CategoryName) then  begin
        CategoryName  :=  BoardList[i].CategoryName;
        CategoryNode  :=  TreeView1.Items.AddChild(ParentNode, CategoryName);
        CategoryNode.ImageIndex     :=  7;
        CategoryNode.SelectedIndex  :=  8;
        CategoryNode.Data :=  nil;
      end;
      Node  :=  TreeView1.Items.AddChild(CategoryNode, BoardList[i].Name);
      if ((AnsiPos(BoardList[i].Site.SiteID,  NGWord1.Text) > 0) and
          (AnsiPos(BoardList[i].BoardID, NGWord1.Text) > 0)) or
         ((AnsiPos(BoardList[i].Site.SiteID,  NGWord2.Text) > 0) and
          (AnsiPos(BoardList[i].BoardID, NGWord2.Text) > 0)) then
      begin
        Node.ImageIndex     :=  15;
        Node.SelectedIndex  :=  15;
        ComboBox1.Items.Objects[ComboBox1.Items.Add(BoardList[i].Name)] :=  BoardList[i];
      end else begin
        Node.ImageIndex     :=  14;
        Node.SelectedIndex  :=  14;
      end;
      New(NodeData);
      NodeData.SiteID     :=  BoardList[i].Site.SiteID;
      NodeData.BoardID    :=  BoardList[i].BoardID;
      NodeData.Name       :=  BoardList[i].Name;
      NodeData.Url        :=  BoardList[i].Url;
      NodeData.IsAll      :=  False;
      Node.Data           :=  NodeData;
    end;
    NGWord1.Free;
    NGWord2.Free;
  end;
var
  Node    : TTreeNode;
  NodeData : PNodeData;
  i: integer;
begin
  TreeView1.Items.BeginUpdate;
  TreeView1.Items.Clear;
  for i :=  0 to  ZonuEnviron.SiteList.Count - 1 do  begin
    if  (ZonuEnviron.SiteList[i] <> ZonuEnviron.FavoritesSite)  then  begin
      _BuildBoardList(ZonuEnviron.SiteList[i],
                      ZonuEnviron.SiteList[i].SiteName,
                      ZonuEnviron.SiteList[i].BoardList);
    end;
  end;
  TreeView1.Items.EndUpdate;

  Node  :=  TreeView1.Items.AddChild(nil, '[ׂ]');
  Node.ImageIndex     :=  7;
  Node.SelectedIndex  :=  8;
  New(NodeData);
  NodeData.SiteID     :=  '#ALL';
  NodeData.BoardID    :=  '#ALL';
  NodeData.Name       :=  'ׂ';
  NodeData.Url        :=  '#ALL';
  NodeData.IsAll      :=  True;
  Node.Data           :=  NodeData;
end;

procedure TActionDialog.dfsExtListView1Change(Sender: TObject;
  Item: TListItem; Change: TItemChange);
var
  Site: TSite;
  Board: TBoard;
  AItem: TListItem;
  ac: TZonuAction;
  i: integer;
begin
  if  (Showing) then  begin
    dfsExtListView2.Items.Clear;
    dfsExtListView3.Items.Clear;
    if  (Item <> nil) then  begin
      if  (Item.Data <> nil)  then  begin
        ac  :=  TZonuAction(Item.Data);
        for i :=  0 to  ac.TargetBoardList.Count - 1  do  begin
          if  (ac.TargetBoardList[i].IsAll) then  begin
            AItem   :=  dfsExtListView2.Items.Add;
            AItem.Caption :=  '(S)';
          end else begin
            if  (ZonuEnviron.SiteList.FindSite(ac.TargetBoardList[i].SiteID, Site)) then  begin
              AItem   :=  dfsExtListView2.Items.Add;
              AItem.Caption :=  Site.SiteName;
              if  (Site.BoardList.FindBoard(ac.TargetBoardList[i].BoardID, Board))  then  begin
                AItem.SubItems.Add(Board.Name);
              end;
            end;
          end;
        end;
        if  (atResHandle  in  ac.Target)  then  begin
          AItem :=  dfsExtListView3.Items.Add;
          AItem.Caption :=  'XEnh';
        end;
        if  (atResMail  in  ac.Target)  then  begin
          AItem :=  dfsExtListView3.Items.Add;
          AItem.Caption :=  'XE[';
        end;
        if  (atResID  in  ac.Target)  then  begin
          AItem :=  dfsExtListView3.Items.Add;
          AItem.Caption :=  'XEID';
        end;
        if  (atResBody  in  ac.Target)  then  begin
          AItem :=  dfsExtListView3.Items.Add;
          AItem.Caption :=  'XE{';
        end;
        if  (atThreadTitle  in  ac.Target)  then  begin
          AItem :=  dfsExtListView3.Items.Add;
          AItem.Caption :=  'XbhE^Cg';
        end;
        if  (atThreadResCount  in  ac.Target)  then  begin
          AItem :=  dfsExtListView3.Items.Add;
          AItem.Caption :=  'XbhEX';
        end;
        if  (atThreadLoadDate  in  ac.Target)  then  begin
          AItem :=  dfsExtListView3.Items.Add;
          AItem.Caption :=  'XbhEŏI擾';
        end;
      end;
    end;
  end;
end;

procedure TActionDialog.ComboBox1Change(Sender: TObject);
var
  i : integer;
begin
  if  (ComboBox1.Items.Objects[ComboBox1.ItemIndex] <>  nil)  then  begin
    for i :=  0 to  TreeView1.Items.Count - 1 do  begin
      if  (TreeView1.Items[i].Data <> nil)  then  begin
        if  (PNodeData(TreeView1.Items[i].Data).SiteID = TBoard(ComboBox1.Items.Objects[ComboBox1.ItemIndex]).Site.SiteID) and
            (PNodeData(TreeView1.Items[i].Data).BoardID = TBoard(ComboBox1.Items.Objects[ComboBox1.ItemIndex]).BoardID)  then
        begin
          TreeView1.Selected  :=  TreeView1.Items[i];
          Break;
        end;
      end;
    end;
  end;
end;

procedure TActionDialog.TreeView1Change(Sender: TObject; Node: TTreeNode);
  procedure BuildList(ActionList: TZonuActionList);
  var
    i, x:  integer;
    b : boolean;
    Item  : TListItem;
  begin
    for i :=  0 to  ActionList.Count - 1  do  begin
      for x :=  0 to  ActionList.Items[i].TargetBoardList.Count - 1 do  begin
        b :=  False;
        if  (PNodeData(Node.Data).SiteID =  ActionList.Items[i].TargetBoardList[x].SiteID) and
            (PNodeData(Node.Data).BoardID =  ActionList.Items[i].TargetBoardList[x].BoardID)  then
        begin
          b :=  True;
        end;

        if  (ActionList.Items[i].TargetBoardList[x].IsAll) and (not CheckBox1.Checked) then  b :=  True;
        if  (PNodeData(Node.Data).IsAll) and (ActionList.Items[i].TargetBoardList[x].IsAll) then  b :=  True;
        if  (b) then  begin
          Item  :=  AddActionItem(ActionList[i], dfsExtListView4);
          Item.Data       :=  ActionList.Items[i];
          if  (not PNodeData(Node.Data).IsAll) and (ActionList.Items[i].TargetBoardList[x].IsAll) then  begin
            Item.Cut  :=  True;
          end;
        end;
      end;
    end;
  end;
begin
  dfsExtListView4.Items.Clear;
  if  (Node <> nil) then  begin
    if  (Node.Data <> nil)  then  begin
      BuildList(FResActionList);
      BuildList(FThreadActionList);
    end;
  end;
end;



function TActionDialog.AddActionItem(ActionItem:  TZonuAction;
  ListView: TdfsExtListView): TListItem;
var
  Item: TListItem;
begin
    Item  :=  ListView.Items.Add;
    if  (ActionItem.ActionType = atAbone) then  begin
      Item.Caption    :=  '';
      Item.ImageIndex :=  0;
    end else
    if  (ActionItem.ActionType = atReplace) then  begin
      Item.Caption  :=  'u';
      Item.ImageIndex :=  1;
    end else
    if  (ActionItem.ActionType = atPopup) then  begin
      Item.Caption  :=  'ʒm';
      Item.ImageIndex :=  2;
    end else
    if  (ActionItem.ActionType = atAddToFav) then  begin
      Item.Caption  :=  'Cɓ';
      Item.ImageIndex :=  3;
    end else
    if  (ActionItem.ActionType = atMoveToLocal) then  begin
      Item.Caption  :=  '[J';
      Item.ImageIndex :=  4;
    end else
    if  (ActionItem.ActionType = atBookmark) then  begin
      Item.Caption  :=  '';
      Item.ImageIndex :=  5;
    end else
    if  (ActionItem.ActionType = atSetColor) then  begin
      Item.Caption  :=  'F';
      Item.ImageIndex :=  6;
    end else
    if  (ActionItem.ActionType = atSetReverse) then  begin
      Item.Caption  :=  'F]';
      Item.ImageIndex :=  7;
    end else
    if  (ActionItem.ActionType = atSetBold) then  begin
      Item.Caption  :=  '';
      Item.ImageIndex :=  8;
    end else
    if  (ActionItem.ActionType = atSetKakoLog) then  begin
      Item.Caption  :=  'ߋO';
      Item.ImageIndex :=  9;
    end;
    if  (ActionItem.ActionWhere = awLike) then  begin
      Item.SubItems.Add('w蕶܂');
    end else
    if  (ActionItem.ActionWhere = awSame) then  begin
      Item.SubItems.Add('w蕶ƈv');
    end else
    if  (ActionItem.ActionWhere = awLengthLT) then  begin
      Item.SubItems.Add('w萔ȉ');
    end else
    if  (ActionItem.ActionWhere = awLengthGT) then  begin
      Item.SubItems.Add('w萔ȏ');
    end else
    if  (ActionItem.ActionWhere = awCountGT) then  begin
      Item.SubItems.Add('Xw萔z');
    end else
    if  (ActionItem.ActionWhere = awDateGT) then  begin
      Item.SubItems.Add('ŏIǍwo߂');
    end else
    if  (ActionItem.ActionWhere = awNonGetCountGT) then  begin
      Item.SubItems.Add('擾Xw萔z');
    end;
    Item.SubItems.Add(ActionItem.Param1);
    Item.SubItems.Add(ActionItem.Param2);
    //9 begin
    Item.SubItems.Add(IntToStr(ActionItem.HitCount));
    Item.SubItems.Add(ActionItem.LastExecuted);
    //9 end
    //12
    Item.SubItems.Add(ActionItem.Comment);
    //13
    Item.SubItems.Add(ActionItem.CreateTime);
    Item.Data :=  ActionItem;
    Result    :=  Item;
end;

procedure TActionDialog.CheckBox1Click(Sender: TObject);
begin
  TreeView1.OnChange(TreeView1, TreeView1.Selected);
end;

procedure TActionDialog.actAddExecute(Sender: TObject);
var
  ac: TZonuAction;
  Browser: TZonuBrowser;
  ListDoc: TZonuListDoc;
  ActionList: TZonuActionList;
  ak : TActionKind;
begin
  if  (TabControl1.TabIndex = 0)  then  begin
    ActionList  :=  FResActionList;
    ak  :=  akRes;
  end else begin
    ActionList  :=  FThreadActionList;
    ak  :=  akThread;
  end;

  ac  :=  TZonuAction.Create;
  if  (PageControl1.ActivePageIndex = 1)  then  begin
    if  (dfsExtListView1.Selected <> nil) then  begin
      if  (dfsExtListView1.Selected.Data <> nil) then  begin
        ActionDialog2.Add(ak, ac,
                          PNodeData(dfsExtListView1.Selected.Data).SiteID,
                          PNodeData(dfsExtListView1.Selected.Data).BoardID);
      end else begin
        ActionDialog2.Add(ak, ac, '', '');
      end;
    end else begin
      ActionDialog2.Add(ak, ac, '', '');
    end;
  end else begin
    if  (HotzonuWindow.GetActiveBrowser(Browser))  then  begin
      ActionDialog2.Add(ak, ac, Browser.Board.Site.SiteID, Browser.Board.BoardID);
    end else
    if  (HotzonuWindow.GetActiveListDoc(ListDoc))  then  begin
      ActionDialog2.Add(ak, ac, ListDoc.Board.Site.SiteID, ListDoc.Board.BoardID);
    end else begin
      ActionDialog2.Add(ak, ac, '', '');
    end;
  end;
  ///////////////////////////////////////////////////
  SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  if  (ActionDialog2.ShowModal = mrOk)  then  begin
    ActionList.Add(ac);
    if  (PageControl1.ActivePageIndex = 0)  then  begin
      dfsExtListView1.Items.Clear;
      BuildActionList(ActionList);
    end else begin
      TreeView1.OnChange(Self,  TreeView1.Selected);
    end;
  end else begin
    ac.Free;
  end;
  SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
end;

procedure TActionDialog.actEditExecute(Sender: TObject);
var
  ak: TActionKind;
begin
  if  (TabControl1.TabIndex = 0)  then  begin
    ak  :=  akRes;
  end else begin
    ak  :=  akThread;
  end;
  if  (PageControl1.ActivePageIndex = 1)  then  begin
    if  (dfsExtListView4.Selected <> nil) then  begin
      ActionDialog2.Edit(ak, TZonuAction(dfsExtListView4.Selected.Data));
    end else begin
      Exit;
    end;
  end else begin
    if  (dfsExtListView1.Selected <> nil) then  begin
      ActionDialog2.Edit(ak, TZonuAction(dfsExtListView1.Selected.Data));
    end else begin
      Exit;
    end;
  end;
  /////////////////////////////////////////////////
  SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  if  (ActionDialog2.ShowModal = mrOk)  then  begin
    if  (PageControl1.ActivePageIndex = 0)  then  begin
      dfsExtListView1.Items.Clear;
      //BuildActionList();
      TabControl1.OnChange(TabControl1);
    end else begin
      TreeView1.OnChange(Self,  TreeView1.Selected);
    end;
  end;
  SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
end;

procedure TActionDialog.actDeleteExecute(Sender: TObject);
var
  AAction : TZonuAction;
  ActionList: TZonuActionList;
  i : integer;
begin
  AAction :=  nil;
  if  (TabControl1.TabIndex = 0)  then  begin
    ActionList  :=  FResActionList;
  end else begin
    ActionList  :=  FThreadActionList;
  end;
  if  (PageControl1.ActivePageIndex = 0)  then  begin
    if  (dfsExtListView1.Selected <> nil) then  begin
      AAction :=  TZonuAction(dfsExtListView1.Selected.Data);
    end;
  end else begin
    if  (dfsExtListView4.Selected <> nil) then  begin
      AAction :=  TZonuAction(dfsExtListView4.Selected.Data);
    end;
  end;

  if  (AAction <> nil)  then  begin
    SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
    if  (MessageDlg('폜܂H', mtWarning, [mbYes, mbNo], 0) = mrYes)  then
    begin
      for i :=  0 to  ActionList.Count - 1  do  begin
        if  (ActionList[i] = AAction) then  begin
          ActionList[i].TargetBoardList.Clear;
          ActionList.Delete(i);
          dfsExtListView2.Items.Clear;
          dfsExtListView3.Items.Clear;
          Break;
        end;
      end;
      if  (PageControl1.ActivePageIndex = 0)  then  begin
        BuildActionList(ActionList);
      end else begin
        TreeView1.OnChange(Self, TreeView1.Selected);
      end;
    end;
    SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  end;
end;

procedure TActionDialog.FormActivate(Sender: TObject);
begin
  if  (ActionDialog2 = nil) then  begin
    Screen.Cursor :=  crHourglass;
    ActionDialog2 :=  TActionDialog2.Create(Self);
    Screen.Cursor :=  crDefault;
  end;
  AlphaBlend  :=  False;
  if  (ZonuConfig.ActionDialogExpand) then  begin
    SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  end;
  Height  :=  FSaveHeight;
end;

procedure TActionDialog.SaveActions;
begin
  FResActionList.SaveToFile(ZonuConfig.UsersPath + FILE_RES_ACTION);
  FThreadActionList.SaveToFile(ZonuConfig.UsersPath + FILE_THREAD_ACTION);
end;

procedure TActionDialog.FormHide(Sender: TObject);
var
  i: integer;
begin
  ZonuConfig.ActionPosTop     :=  Top;
  ZonuConfig.ActionPosLeft    :=  Left;
  ZonuConfig.ActionWidth      :=  Width;
  ZonuConfig.ActionHeight     :=  Height;
  ZonuConfig.ActionPane2Size  :=  dfsExtListView4.Width;
  if  (Panel3.Width < 2)  then  begin
    ZonuConfig.ActionPane1Size  :=  0;
  end else begin
    ZonuConfig.ActionPane1Size  :=  Panel3.Width;
  end;
  for i :=  0 to  dfsExtListView1.Columns.Count - 1 do  begin
    ZonuConfig.ActionColumnWidth[i] :=  dfsExtListView1.Columns[i].Width;
  end;
end;

procedure TActionDialog.FormShow(Sender: TObject);
var
  i: integer;
begin
  SetBounds(
    ZonuConfig.ActionPosLeft,
    ZonuConfig.ActionPosTop,
    ZonuConfig.ActionWidth,
    ZonuConfig.ActionHeight);
  dfsExtListView4.Width :=  ZonuConfig.ActionPane2Size;
  if  (ZonuConfig.ActionPane1Size = 0)  then  begin
    ZonuSplitter1.ClosePane;
  end else begin
    Panel3.Width          :=  ZonuConfig.ActionPane1Size;
  end;
  for i :=  0 to  dfsExtListView1.Columns.Count - 1 do  begin
    dfsExtListView1.Columns[i].Width  :=  ZonuConfig.ActionColumnWidth[i];
  end;
end;

procedure TActionDialog.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  SaveActions;
  //DeleteWindowlist(Self);
end;

procedure TActionDialog.Init;
begin
  BuildBoardList;
  TabControl1.OnChange(TabControl1);  
end;

procedure TActionDialog.TabControl1Change(Sender: TObject);
begin
  if  (TabControl1.TabIndex = 0)  then  begin
    BuildActionList(FResActionList);
  end else begin
    BuildActionList(FThreadActionList);
  end;
end;

procedure TActionDialog.FormDeactivate(Sender: TObject);
begin
  if  (ZonuConfig.ActionDialogTrans)  then
  begin
    //TransWindow(True);
    AlphaBlend  :=  True;
    AlphaBlendValue :=  128;
  end;
  FSaveHeight :=  Height;
  if  (ZonuConfig.ActionDialogExpand) then  begin
    Height      :=  0;
  end;
end;

procedure TActionDialog.actRefreshExecute(Sender: TObject);
begin
  HotzonuWindow.actThreadExecAction.Execute;
end;

//13
procedure TActionDialog.actAddBatchExecute(Sender: TObject);
var
  ac: TZonuAction;
  tb: TTargetBoard;
  i: integer;
begin
  NGWordDialog  :=  TNGWordDialog.Create(Self);
  if  (NGWordDialog.ShowModal = mrOk) then  begin
    for i :=  0 to  NGWordDialog.NGWords.Count - 1  do  begin
      ac  :=  TZonuAction.Create;
      ac.Target           :=  [atResHandle, atResMail, atResID, atResBody];
      ac.ActionWhere      :=  awLike;
      ac.ActionType       :=  atAbone;
      ac.AboneHideInPopup :=  NGWordDialog.CheckBox1.Checked;
      ac.AboneRelation    :=  NGWordDialog.CheckBox2.Checked;
      ac.Param1           :=  NGWordDialog.NGWords[i];
      ac.Comment          :=  '';
      ac.TermTime         :=  0;
      ac.CreateTime       :=  FormatDateTime('yyyy/mm/dd hh:nn:ss', Now);
      tb  :=  TTargetBoard.Create;
      tb.IsAll  :=  True;
      ac.TargetBoardList.Add(tb);
      FResActionList.Add(ac);
    end;
    dfsExtListView1.Items.Clear;
    BuildActionList(FResActionList);
  end;
end;

end.
