{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Board Editor Unit                                                 }
{                                                                             }
{ 2001-05 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Boardedt;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, FileCtrl, ZonuClass, ExtCtrls, Dlghead, Hzbconst;

type
  TEditMode = (emNew, emEdit);
  TBoardEditor = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ComboBox1: TComboBox;
    Label3: TLabel;
    HeaderFrame1: THeaderFrame;
    grpCharSet: TRadioGroup;
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
    FSite: TSite;
    FBoardID: string;
    FBoardPath: string;
    FEditMode: TEditMode;
    FBoard: TBoard;
    procedure SetSite(const Value: TSite);
    function GetBoardName: string;
    function GetCategoryName: string;
    function GetPath: string;
    procedure SetBoardName(const Value: string);
    procedure SetCategoryName(const Value: string);
    procedure SetPath(const Value: string);
    function GetBoardID: string;
    function GetBoardPath: string;
    procedure SetCharSet(const Value: TCharSet);  //age16
    function GetCharSet: TCharSet;  //age16
  public
    { Public 錾 }
    property  Site: TSite   read  FSite write SetSite;
    property  Board: TBoard read  FBoard  write FBoard;
    property  BoardName: string   read  GetBoardName    write SetBoardName;
    property  CategoryName: string  read  GetCategoryName write SetCategoryName;
    property  Path: string  read  GetPath write SetPath;
    property  BoardID: string read  GetBoardID;
    property  BoardPath:  string  read  GetBoardPath;
    property  EditMode: TEditMode read  FEditMode write FEditMode;
    property  CharSet: TCharSet read  GetCharSet  write SetCharSet; //age16
  end;

var
  BoardEditor: TBoardEditor;

implementation

{$R *.dfm}

uses
  MonaUtils, IniFiles, ZonuConf;

{ TBBSEditor }

function TBoardEditor.GetBoardID: string;
begin
  Result  :=  FBoardID;
end;

function TBoardEditor.GetBoardName: string;
begin
  Result  :=  Edit1.Text;
end;

function TBoardEditor.GetBoardPath: string;
begin
  Result  :=  FBoardPath;
end;

function TBoardEditor.GetCategoryName: string;
begin
  Result  :=  ComboBox1.Text;
end;

function TBoardEditor.GetPath: string;
begin
  Result  :=  Edit2.Text;
end;

procedure TBoardEditor.SetBoardName(const Value: string);
begin
  Edit1.Text  :=  Value;
end;

procedure TBoardEditor.SetCategoryName(const Value: string);
begin
  ComboBox1.Text  :=  Value;
end;

procedure TBoardEditor.SetPath(const Value: string);
begin
  Edit2.Text  :=  Value;
end;

procedure TBoardEditor.SetSite(const Value: TSite);
var
  CategoryName : string;
  i : integer;
begin
  FSite         :=  Value;
  CategoryName  :=  '';
  for i :=  0 to  FSite.BoardList.Count - 1 do  begin
    if  (CategoryName <>  FSite.BoardList[i].CategoryName)  then  begin
      CategoryName  :=  FSite.BoardList[i].CategoryName;
      ComboBox1.Items.Add(CategoryName);
    end;
  end;
  if  (ComboBox1.Items.Count > 0) then  begin
    ComboBox1.ItemIndex :=  0;
  end;
  Button1.Enabled :=  (FSite.SiteType = stLocal);
  if  (FSite.SiteType = stFavorites)  then  begin
    Edit2.Enabled   :=  False;
    Button1.Enabled :=  False;
    Edit2.Color     :=  clBtnFace;
    Label2.Font.Color :=  clBtnShadow;
  end;
end;

procedure TBoardEditor.Button2Click(Sender: TObject);
var
  ini : TMemIniFile;
  sl  : TStringList;
  Board : TBoard;
  s : string;
  i, n : integer;
begin
  if  (Trim(Edit1.Text) = '') then  begin
    MessageDlg('͂ĂB', mtError, [mbOk], 0);
    Edit1.SetFocus;
    Exit;
  end else
  if  (FSite.SiteType <> stFavorites)  then  begin
    if  (Trim(Edit2.Text) = '') then  begin
      MessageDlg('pX͂ĂB', mtError, [mbOk], 0);
      Edit2.SetFocus;
      Exit;
    end;
  end;
  if  (FSite.SiteType = stFavorites)  then  begin
    if  (ComboBox1.Text = '') then  begin
      MessageDlg('JeS͂ĂB', mtError, [mbOk], 0);
      ComboBox1.SetFocus;
      Exit;
    end;
  end;
  if  (FSite.SiteType  = stFavorites) and (EditMode = emNew) then  begin
    ini         :=  TMemIniFile.Create(ZonuConfig.UsersPath + PATH_CONFIG + PATH_FAVORITES + INI_SITE);
    n           :=  ini.ReadInteger('LIST', 'USED', 0) + 1;
    FBoardID    :=  Format('fav%.5d', [n]);
    FBoardPath  :=  BOARDPATH_FAV;
    ini.WriteInteger('LIST', 'USED', n);
    ini.UpdateFile;
    sl          :=  TStringList.Create;
    sl.Add(Edit1.Text);
    sl.SaveToFile(ZonuConfig.UsersPath + PATH_CONFIG + PATH_FAVORITES + FBoardID + '.txt');
    sl.Free;
    ini.Free;
  end else
  if  (FSite.SiteType  = stLocal) and (EditMode = emNew)  then  begin
    ini         :=  TMemIniFile.Create(ZonuConfig.UsersPath + PATH_CONFIG + PATH_LOCAL + INI_SITE);
    n           :=  ini.ReadInteger('LIST', 'USED', 0) + 1;
    FBoardID    :=  Format('local%.5d', [n]);
    FBoardPath  :=  IncludeTrailingPathDelimiter(Edit2.Text);
    ini.WriteInteger('LIST', 'USED', n);
    ini.UpdateFile;
    ini.Free;
  end else 
  if  (Edit2.Enabled) and ((FSite.SiteType  = stNormal) or (FSite.SiteType  = stUser)) then  begin
    s :=  Edit2.Text;
    if  (s[Length(s)] = '/')  then  begin
      s           :=  Copy(S, 1, Length(S) - 1);
    end;
    FBoardID    :=  ExtractUrlName(s);
    s           :=  Copy(ExtractUrlPath(s), 8, Length(s));
    FBoardPath  :=  Copy(s, 1, Length(s) - 1);
    if  (EditMode = emNew)  then  begin
      if  (Site.BoardList.FindBoard(FBoardID, Board)) then  begin
        MessageDlg(FBoardID + '͂łɓo^ĂIDƏd܂B' + #13#10 +
                   '@w' + Board.Name + 'x',
                   mtError, [mbOk], 0);
        Exit;
      end;
    end else begin
      for i :=  0 to  Site.BoardList.Count - 1  do  begin
        if  (Site.BoardList[i].BoardID = FBoardID)  and
            (Site.BoardList[i]  <>  FBoard) then
        begin
          MessageDlg(FBoardID + '͂łɓo^ĂIDƏd܂B' + #13#10 +
                     '@w' + Site.BoardList[i].Name + 'x',
                     mtError, [mbOk], 0);
          Exit;
        end;
      end;
    end;
  end else begin
    FBoardPath  :=  FBoard.BoardPath;
    FBoardID    :=  FBoard.BoardID;
  end;
  ModalResult :=  mrOk;
end;

procedure TBoardEditor.Button3Click(Sender: TObject);
begin
  ModalResult :=  mrCancel;
end;

procedure TBoardEditor.Button1Click(Sender: TObject);
var
  S : string;
begin
  if  (Edit2.Text <> '')  then  begin
    S :=  Edit2.Text;
  end else begin
    S :=  ZonuConfig.LocalFolderLastPath;
  end;
  if (SelectDirectory(S, [sdAllowCreate, sdPrompt], 0)) then  begin
    Edit2.Text  :=  IncludeTrailingPathDelimiter(S);
    ZonuConfig.LocalFolderLastPath  :=  s;
  end;
end;

//age16
procedure TBoardEditor.SetCharSet(const Value: TCharSet);
begin
  if  (Value = csSJIS) then  begin
    grpCharSet.ItemIndex  :=  0;
  end else
  if  (Value = csEUC) then  begin
    grpCharSet.ItemIndex  :=  1;
  end else
  if  (Value = csUTF8) then  begin  //14
    grpCharSet.ItemIndex  :=  2;    //14
  end;
end;

//age16
function TBoardEditor.GetCharSet: TCharSet;
begin
  if  (grpCharSet.ItemIndex = 0)  then  begin
    Result  :=  csSJIS;
  end else
  if  (grpCharSet.ItemIndex = 1)  then  begin
    Result  :=  csEUC;
  end else
  if  (grpCharSet.ItemIndex = 2)  then  begin  //14
    Result  :=  csUTF8; //14
  end else begin
    Result  :=  csSJIS;
  end;
end;

end.
