unit Debugdlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ZonuClass, StdCtrls;

type
  TDebugForm = class(TForm)
    StatusBar1: TStatusBar;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    ListView1: TListView;
    TabSheet2: TTabSheet;
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private 錾 }
    procedure ThreadItemAddRef(Sender: TObject);
    procedure ThreadItemReleaseRef(Sender: TObject);
    procedure ThreadItemDestroy(Sender: TObject);
    procedure ThreadItemChange(ThreadItem: TThreadItem);
  public
    { Public 錾 }
    procedure Build(ThreadItemList: TThreadItemList);
  end;

var
  DebugForm: TDebugForm;

implementation

{$R *.dfm}

{ TDebugForm }

procedure TDebugForm.Build(ThreadItemList: TThreadItemList);
var
  i:  integer;
  Item: TListItem;
begin
  for i :=  0 to  ThreadItemList.Count - 1  do  begin
    Item  :=  ListView1.Items.Add;
    Item.Caption  :=  ThreadItemList[i].DatNo;
    Item.SubItems.Add(ThreadItemList[i].Title);
    Item.SubItems.Add(IntToStr(ThreadItemList[i].RefCount));
    Item.Data :=  ThreadItemList[i];
    ThreadItemList[i].OnAddRef      :=  ThreadItemAddRef;
    ThreadItemList[i].OnReleaseRef  :=  ThreadItemReleaseRef;
    ThreadItemList[i].OnDestroy     :=  ThreadItemDestroy;
  end;
end;

procedure TDebugForm.ThreadItemAddRef(Sender: TObject);
begin
  ThreadItemChange(TThreadItem(Sender));
end;

procedure TDebugForm.ThreadItemDestroy(Sender: TObject);
begin
  ThreadItemChange(TThreadItem(Sender));
end;

procedure TDebugForm.ThreadItemReleaseRef(Sender: TObject);
begin
  ThreadItemChange(TThreadItem(Sender));
end;

procedure TDebugForm.ThreadItemChange(ThreadItem: TThreadItem);
var
  i: integer;
  Item: TListItem;
begin
  for i :=  0 to  ListView1.Items.Count - 1 do  begin
    if  (ListView1.Items[i].Data <> nil)  then  begin
      if  (TObject(ListView1.Items[i].Data) = ThreadItem) then  begin
        ListView1.Items[i].Delete;
        Item  :=  ListView1.Items.Insert(0);
        Item.Caption  :=  ThreadItem.DatNo;
        Item.SubItems.Add(ThreadItem.Title);
        Item.SubItems.Add(IntToStr(ThreadItem.RefCount));
        Item.Data :=  ThreadItem;
        if  (ThreadItem.RefCount = 0) then  begin
          Item.Data :=  nil;
        end;
        Update;
        Break;
      end;
    end;
  end;
end;

procedure TDebugForm.FormActivate(Sender: TObject);
begin
  SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
end;

procedure TDebugForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
end;

end.
