{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Favorite Editor Unit                                              }
{                                                                             }
{ 2001-04 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Favedt;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, Main, EnhListView, ExtListView, ZonuConf,
  Hzbconst, Hzbclass, Hzbfunc, ZonuClass, ZonuFavorites, ActnList, StdCtrls,
  Menus, ToolWin;

type
  TFavoritesEditor = class(TForm)
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    TreeView1: TTreeView;
    Panel4: TPanel;
    dfsExtListView1: TdfsExtListView;
    ActionList1: TActionList;
    Label1: TLabel;
    actSelectAll: TAction;
    actSelectKakoLog: TAction;
    actSelectOver1000: TAction;
    PopupMenu1: TPopupMenu;
    SelectAll1: TMenuItem;
    K1: TMenuItem;
    N1000T1: TMenuItem;
    actDelete: TAction;
    N2: TMenuItem;
    D1: TMenuItem;
    actErase: TAction;
    E1: TMenuItem;
    Panel3: TPanel;
    actThreadMoveUp: TAction;
    actThreadMoveDown: TAction;
    N1: TMenuItem;
    U1: TMenuItem;
    D2: TMenuItem;
    actFolderDelete: TAction;
    actFolderEdit: TAction;
    actFolderNew: TAction;
    PopupMenu2: TPopupMenu;
    N3: TMenuItem;
    Edit1: TMenuItem;
    Delete1: TMenuItem;
    Timer1: TTimer;
    actFolderMoveUp: TAction;
    actFolderMoveDown: TAction;
    N4: TMenuItem;
    N5: TMenuItem;
    U2: TMenuItem;
    D3: TMenuItem;
    actProperty: TAction;
    N6: TMenuItem;
    Property1: TMenuItem;
    actSetKakoLog: TAction;
    N7: TMenuItem;
    K2: TMenuItem;
    actMoveToLocal: TAction;
    N8: TMenuItem;
    L1: TMenuItem;
    actWebEditUrl: TAction;
    actWebEditTitle: TAction;
    N9: TMenuItem;
    T1: TMenuItem;
    URLU1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure FormDestroy(Sender: TObject);
    procedure dfsExtListView1DrawItem(Control: TWinControl;
      var ACanvas: TCanvas; Index: Integer; ARect: TRect;
      State: TOwnerDrawState; var DefaultDrawing, FullRowSelect: Boolean);
    procedure dfsExtListView1DrawSubItem(Control: TWinControl;
      var ACanvas: TCanvas; Index, SubItem: Integer; ARect: TRect;
      State: TOwnerDrawState; var DefaultDrawing: Boolean);
    procedure dfsExtListView1ColumnClick(Sender: TObject;
      Column: TListColumn);
    procedure dfsExtListView1AfterDefaultDrawItem(Control: TWinControl;
      var ACanvas: TCanvas; Index: Integer; ARect: TRect;
      State: TOwnerDrawState);
    procedure actSelectAllExecute(Sender: TObject);
    procedure actSelectKakoLogExecute(Sender: TObject);
    procedure actDeleteExecute(Sender: TObject);
    procedure TreeView1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TreeView1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure actThreadMoveUpExecute(Sender: TObject);
    procedure actThreadMoveDownExecute(Sender: TObject);
    procedure TreeView1Changing(Sender: TObject; Node: TTreeNode;
      var AllowChange: Boolean);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure actFolderEditExecute(Sender: TObject);
    procedure actFolderDeleteExecute(Sender: TObject);
    procedure actFolderNewExecute(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure actFolderMoveUpExecute(Sender: TObject);
    procedure actFolderMoveDownExecute(Sender: TObject);
    procedure dfsExtListView1StartDrag(Sender: TObject;
      var DragObject: TDragObject);
    procedure dfsExtListView1DragOver(Sender, Source: TObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure dfsExtListView1DragDrop(Sender, Source: TObject; X,
      Y: Integer);
    procedure TreeView1StartDrag(Sender: TObject;
      var DragObject: TDragObject);
    procedure TreeView1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure TreeView1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure actPropertyExecute(Sender: TObject);
    procedure actMoveToLocalExecute(Sender: TObject);
    procedure actWebEditUrlExecute(Sender: TObject);
    procedure PopupMenu2Popup(Sender: TObject);
  private
    { Private 錾 }
    FThreadItemList: TThreadItemList;
    FCurrentBoard: TBoard;
    FBmpKakoLog: TBitmap;
    FSortIndex: integer;
    FAscend : boolean;
    FModified: boolean;
    FListViewDragging: boolean;
    FListViewX, FListViewY: integer;
    FDragNode: TTreeNode;
    procedure BuildThreadList(Board: TBoard);
    procedure ThreadListDownload(Sender: TThreadListDownloader;
      ThreadItem: TThreadItem; Size, TotalSize: integer;
      var MoreData: boolean);
    procedure ThreadListEndDownload(Sender: TDownloader; Error: boolean);
    procedure ThreadListError(Sender: TDownloader; ErrorCode: integer;
      ErrorMsg: string);
    procedure LoadScreenConfig;
    procedure SaveScreenConfig;
    procedure SaveThreadList;
  public
    { Public 錾 }
  end;

var
  FavoritesEditor: TFavoritesEditor;

implementation

{$R *.dfm}

uses
  Boardedt, Propdlg, Localdlg, Zonutils;

procedure TFavoritesEditor.FormCreate(Sender: TObject);
begin
  FThreadItemList :=  TThreadItemList.Create;
  FBmpKakoLog     :=  TBitmap.Create;
  FSortIndex      :=  0;
  FAscend         :=  True;
  FModified       :=  False;
  FCurrentBoard   :=  nil;
  HotzonuWindow.DrawImage.GetBitmap(6, FBmpKakoLog);
  if  (ZonuEnviron.FavoritesSite <> nil)  then  begin
    Hzbfunc.BuildBoardList(TreeView1, ZonuEnviron.FavoritesSite);
    TreeView1.FullExpand;
  end else begin
    //
  end;
  LoadScreenConfig;
  Timer1.Enabled  :=  True;
end;

procedure TFavoritesEditor.FormDestroy(Sender: TObject);
begin
  SaveScreenConfig;
  FThreadItemList.Clear;
  FThreadItemList.Free;
  FBmpKakoLog.Free;
end;

procedure TFavoritesEditor.TreeView1Change(Sender: TObject;
  Node: TTreeNode);
begin
  FCurrentBoard :=  nil;
  StatusBar1.Panels[0].Text :=  '';
  dfsExtListView1.SetItemCountEx(0, []);
  actWebEditUrl.Enabled   :=  False;
  actWebEditTitle.Enabled :=  False;
  if  (Node <> nil) then  begin
    if  (Node.Data <> nil)  then  begin
      if  (TObject(Node.Data) is TBoard)  then  begin
        if  (TBoard(Node.Data).BoardType = btFavorites)  then begin
          BuildThreadList(TBoard(Node.Data));
          StatusBar1.Panels[0].Text :=  Format('%d ', [FThreadItemList.Count]);
          FCurrentBoard :=  TBoard(Node.Data);
        end else
        if  (TBoard(Node.Data).BoardType = btWebPage)  then begin
          actWebEditUrl.Enabled   :=  True;
          actWebEditTitle.Enabled :=  True;
        end;
      end;
    end;
  end;
end;

procedure TFavoritesEditor.BuildThreadList(Board: TBoard);
var
  BBS : TBBS;
  Downloader  : TThreadListDownloader;
begin
  BBS :=  ZonuEnviron.FavoritesSite.BBS;
  FThreadItemList.BBS   :=  BBS;
  FThreadItemList.Site  :=  ZonuEnviron.FavoritesSite;
  FThreadItemList.Clear;
  Downloader                :=  TThreadListDownloader.Create;
  Downloader.Site           :=  ZonuEnviron.FavoritesSite;
  Downloader.BBS            :=  BBS;
  Downloader.Board          :=  Board;
  Downloader.ThreadItemList :=  FThreadItemList;
  Downloader.ViewObject     :=  nil;
  Downloader.CharSet        :=  Board.CharSet;
  Downloader.OnData         :=  ThreadListDownload;
  Downloader.OnEnd          :=  ThreadListEndDownload;
  Downloader.OnError        :=  ThreadListError;
  BBS.DownloadThreadList(Downloader, True, True, True);
end;

procedure TFavoritesEditor.ThreadListDownload(Sender: TThreadListDownloader;
  ThreadItem: TThreadItem; Size, TotalSize: integer; var MoreData: boolean);
begin
  if  (ThreadItem <> nil) then  begin
    FThreadItemList.Add(ThreadItem);
  end;
end;

procedure TFavoritesEditor.ThreadListEndDownload(Sender: TDownloader;
  Error: boolean);
begin
  FreeAndNil(Sender);
  dfsExtListView1.SetItemCountEx(FThreadItemList.Count , []);
end;

procedure TFavoritesEditor.ThreadListError(Sender: TDownloader;
  ErrorCode: integer; ErrorMsg: string);
var
  Board : TBoard;
begin
  if  (ErrorCode <> 0)  then  begin
    Board :=  TThreadListDownloader(Sender).Board;
    if  (Board <> nil)  then  begin
      MessageDlg( IntToStr(ErrorCode) + #13#10 + ErrorMsg + #13#10 + #13#10 +
                  'Xbhꗗ_E[hG[' + #13#10 +
                  Board.Name,
                  mtError, [mbOk], 0);
    end;
  end;
end;

procedure TFavoritesEditor.dfsExtListView1AfterDefaultDrawItem(
  Control: TWinControl; var ACanvas: TCanvas; Index: Integer; ARect: TRect;
  State: TOwnerDrawState);
var
  XRect : TRect;
  Text  : string;
begin
  if  (Index < FThreadItemList.Count)  then  begin
    Text  :=  Format('%.4d', [FThreadItemList[Index].No]);
  end else begin
    Text  :=  '';
  end;
  XRect :=  Rect(ARect.Left,
                 RectVertCenter(ARect, ACanvas.TextHeight(Text)),
                 ARect.Left + dfsExtListView1.Columns[0].Width,
                 ARect.Bottom);
  ACanvas.TextRect(XRect, XRect.Left, XRect.Top, Text);
end;

procedure TFavoritesEditor.dfsExtListView1DrawItem(Control: TWinControl;
  var ACanvas: TCanvas; Index: Integer; ARect: TRect;
  State: TOwnerDrawState; var DefaultDrawing, FullRowSelect: Boolean);
var
  ThreadItem : TThreadItem;
begin
  if  (FThreadItemList.Count > Index)  then  begin
    ThreadItem  :=  FThreadItemList[Index];
    if  (not (odSelected in State)) then  begin
      if  (ThreadItem.BBS = nil) then  begin
        ACanvas.Brush.Color :=  ZonuConfig.Headline2chBkColor;
      end;
      ACanvas.Font.Color    :=  ThreadItem.Color;
      if  (ThreadItem.Reverse) then  begin
        ACanvas.Font.Color  :=  clWindow;
        ACanvas.Brush.Color :=  ThreadItem.Color;
      end;
    end;
    ACanvas.Font.Style    :=  [];
    if  (ThreadItem.Bold) then  begin
      ACanvas.Font.Style  :=  [fsBold];
    end;
  end;
  DefaultDrawing  :=  True;
  FullRowSelect   :=  True;
end;

procedure TFavoritesEditor.dfsExtListView1DrawSubItem(Control: TWinControl;
  var ACanvas: TCanvas; Index, SubItem: Integer; ARect: TRect;
  State: TOwnerDrawState; var DefaultDrawing: Boolean);
var
  ThreadItem : TThreadItem;
  AlignRight : boolean;
  Text : string;
  idx  : integer;
begin
  if  (SubItem > -1) then  begin
    if  (FThreadItemList.Count > Index)  then  begin
      ThreadItem  :=  FThreadItemList[Index];
      if  (not (odSelected in State)) then  begin
        ACanvas.Font.Color    :=  ThreadItem.Color;
        if  (ThreadItem.Reverse) then  begin
          ACanvas.Font.Color  :=  clWindow;
          ACanvas.Brush.Color :=  ThreadItem.Color;
        end;
      end else begin
        ACanvas.Font.Color  :=  clHighlightText;
        ACanvas.Brush.Color :=  clHighlight;
      end;
      ACanvas.Font.Style    :=  [];
      if  (ThreadItem.Bold) then  begin
        ACanvas.Font.Style  :=  [fsBold];
      end;
      AlignRight  :=  False;
      Text        :=  '';
      idx         :=  SubItem + 1;
      case  idx of
        //ߋO}[N
        1 :
        begin
          if  (ThreadItem.IsKakoLog)  then  begin
            ACanvas.BrushCopy(
                      Rect(ARect.Left, ARect.Top, ARect.Left + FBmpKakoLog.Width, ARect.Top + FBmpKakoLog.Height),
                      FBmpKakoLog,
                      Rect(0, 0, FBmpKakoLog.Width, FBmpKakoLog.Height),
                      FBmpKakoLog.Canvas.Pixels[0,15]);
          end;
        end;
        //^Cg
        2 :
        begin
          Text  :=  ThreadItem.Title;
        end;
        //
        3 :
        begin
          Text  :=  FormatFloat('####', ThreadItem.DownloadCount);
          AlignRight :=  True;
        end;
        //dvx
        4 :
        begin
          Text  :=  FormatFloat('####', ThreadItem.Priority);
          AlignRight :=  True;
        end;
        //ŏIǂݍݓ
        5 : Text  :=  ThreadItem.LastLoadDate;
        //ŏIݓ
        6 : Text  :=  ThreadItem.LastSentDate;
        //Rg
        7 : Text  :=  ThreadItem.Memo;
        //
        8 :
        begin
          if  (ThreadItem.Board <> nil) then  begin
            Text  :=  ThreadItem.Board.Name;
          end else begin
            Text  :=  '';
          end;
        end;
        //BBS
        9 :
        begin
          if  (ThreadItem.Site <> nil) then  begin
            Text  :=  ThreadItem.Site.SiteName;
          end else begin
            Text  :=  '';
          end;
        end;
        //DAT
        10:
        begin
          Text  :=  ThreadItem.DatNo;
          AlignRight :=  True;
        end;
      end;
      if  (Text <> '')  then  begin
        ARect.Right := ARect.Left + dfsExtListView1.Columns[idx].Width;
        if  (AlignRight)  then  begin
          ACanvas.TextRect(ARect,
                           ARect.Right - Abs(ACanvas.TextWidth(Text)) - 2,
                           RectVertCenter(ARect, ACanvas.TextHeight(Text)),
                           Text);
        end else begin
          ACanvas.TextRect(ARect,
                           ARect.Left,
                           RectVertCenter(ARect, ACanvas.TextHeight(Text)),
                           Text);
        end;
      end;
    end;
  end;
end;

procedure TFavoritesEditor.dfsExtListView1ColumnClick(Sender: TObject;
  Column: TListColumn);
begin
  dfsExtListView1.SetItemCountEx(0, []);
  dfsExtListView1.SetItemCountEx(FThreadItemList.Count, []);
  if  (dfsExtListView1.Items.Count > 0)  then  begin
    dfsExtListView1.Selected :=  nil;
    dfsExtListView1.Selected :=  dfsExtListView1.Items[0];
  end;

  if  (FSortIndex = Column.Index)  then  begin
    FAscend := not FAscend;
  end else begin
    FAscend := True;
  end;
  FSortIndex :=  Column.Index;

  FThreadItemList.CurrentSortAscending := FAscend;
  Case Column.index of
    0 : FThreadItemList.SortItems(isNo,  FAscend);
    1 : FThreadItemList.SortItems(isUpdateInfo,FAscend);
    2 : FThreadItemList.SortItems(isTitle,FAscend);
    3 : FThreadItemList.SortItems(isReadCount,FAscend);
    4 : FThreadItemList.SortItems(isPriority,FAscend);
    5 : FThreadItemList.SortItems(isLastLoadDate,FAscend);
    6 : FThreadItemList.SortItems(isLastSentDate,FAscend);
    7 : FThreadItemList.SortItems(isMemo,FAscend);
    8 : FThreadItemList.SortItems(isBoard,FAscend);
    9 : FThreadItemList.SortItems(isSite,FAscend);
   10 : FThreadItemList.SortItems(isDat,FAscend);
  end;
  dfsExtListView1.Invalidate;
end;

procedure TFavoritesEditor.LoadScreenConfig;
begin
  WindowState :=  ZonuConfig.FavEditWindowState;
  if  (WindowState = wsNormal)  then  begin
    Self.SetBounds( ZonuConfig.FavEditWindowLeft,
                    ZonuConfig.FavEditWindowTop,
                    ZonuConfig.FavEditWindowWidth,
                    ZonuConfig.FavEditWindowHeight);
  end;
  Panel1.Width          :=  ZonuConfig.FavEditPaneWidth;
  TreeView1.RowSelect   :=  (ZonuConfig.FavListSetting = 0);
  TreeView1.AutoExpand  :=  (False);
  TreeView1.HotTrack    :=  (ZonuConfig.FavListSetting = 0);
  dfsExtListView1.Color :=  ZonuConfig.ThreadListBkColor1;
end;

procedure TFavoritesEditor.SaveScreenConfig;
var
  i : integer;
begin
  ZonuConfig.FavEditWindowLeft    :=  Left;
  ZonuConfig.FavEditWindowTop     :=  Top;
  ZonuConfig.FavEditWindowWidth   :=  Width;
  ZonuConfig.FavEditWindowHeight  :=  Height;
  ZonuConfig.FavEditWindowState   :=  WindowState;
  ZonuConfig.FavEditPaneWidth     :=  Panel1.Width;
  for i :=  0 to  dfsExtListView1.Columns.Count - 1  do  begin
    ZonuConfig.FavColumnWidth[i] :=  dfsExtListView1.Columns[i].Width;
  end;
end;
 
procedure TFavoritesEditor.actSelectAllExecute(Sender: TObject);
begin
  dfsExtListView1.SelectAll;
end;

procedure TFavoritesEditor.actSelectKakoLogExecute(Sender: TObject);
var
  ThreadItem  : TThreadItem;
  i : integer;
begin
  for i :=  0 to  dfsExtListView1.Items.Count - 1 do  begin
    ThreadItem  :=  FThreadItemList[i];
    if  (Sender = actSelectKakoLog) and (ThreadItem.IsKakoLog) then  begin
      dfsExtListView1.Items[i].Selected :=  True;
    end else
    if  (Sender = actSelectOver1000) and (ThreadItem.DownloadCount >= 1000) then  begin
      dfsExtListView1.Items[i].Selected :=  True;
    end else begin
      dfsExtListView1.Items[i].Selected :=  False;
    end;
  end;
end;

procedure TFavoritesEditor.TreeView1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  Node : TTreeNode;
begin
  if  (Button = mbRight)  then  begin
    Node  :=  TreeView1.GetNodeAt(X, Y);
    if  (Node <> nil) then  TreeView1.Selected  :=  Node;
  end;
end;

procedure TFavoritesEditor.TreeView1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if  (ZonuConfig.BoardListSetting = 0) then  begin
    if  (not TreeView1.AutoExpand)  then  begin
      if  (TreeView1.Selected <> nil) then  begin
        if  (TreeView1.Selected.Expanded) then  begin
          TreeView1.Selected.Collapse(False);
        end else begin
          TreeView1.Selected.Expand(False);
        end;
      end;
    end;
  end;
end;

//
//  O폜/
//
procedure TFavoritesEditor.actDeleteExecute(Sender: TObject);
var
  ThreadItem  : TThreadItem;
  i : integer;
begin
  for i :=  FThreadItemList.Count - 1 downto  0 do  begin
    if  (dfsExtListView1.Items[i].Selected) then  begin
      ThreadItem  :=  FThreadItemList[i];
      if  (Sender = actSetKakoLog)  then  begin
        ThreadItem.IsKakoLog  :=  not ThreadItem.IsKakoLog;
        ThreadItem.SaveConfig;
      end else begin
        DeleteFromFav(ThreadItem);
        ThreadItem.InFavorites  :=  False;
        if  (Sender = actDelete)  then  begin
          ThreadItem.DeleteLog(True, True, True, True);
        end else begin
          ThreadItem.SaveConfig;
        end;
        ThreadItem.ReleaseRef;
        FThreadItemList.Delete(i);
      end;
      FModified :=  True;
    end;
  end;
  dfsExtListView1.SetItemCountEx(FThreadItemList.Count, []);
end;

procedure TFavoritesEditor.actThreadMoveUpExecute(Sender: TObject);
var
  i : integer;
begin
  for i :=  1 to  FThreadItemList.Count - 1 do  begin
    if  (dfsExtListView1.Items[i].Selected) then  begin
      FThreadItemList.Move(i, i - 1);
      dfsExtListView1.Items[i].Selected     :=  False;
      dfsExtListView1.Items[i - 1].Selected :=  True;
      FModified :=  True;
    end;
  end;
  dfsExtListView1.Invalidate;
end;

procedure TFavoritesEditor.actThreadMoveDownExecute(Sender: TObject);
var
  i : integer;
begin
  for i :=  FThreadItemList.Count - 2 downto  0 do  begin
    if  (dfsExtListView1.Items[i].Selected) then  begin
      FThreadItemList.Move(i, i + 1);
      dfsExtListView1.Items[i].Selected     :=  False;
      dfsExtListView1.Items[i + 1].Selected :=  True;
      FModified :=  True;
    end;
  end;
  dfsExtListView1.Invalidate;
end;

procedure TFavoritesEditor.TreeView1Changing(Sender: TObject;
  Node: TTreeNode; var AllowChange: Boolean);
begin
  SaveThreadList;
end;

procedure TFavoritesEditor.SaveThreadList;
var
  sl: TStringList;
  s: string;
  i: integer;
begin
  if  (FThreadItemList.Count > 0) then  begin
    if  (FModified) and (FCurrentBoard <> nil) then  begin
      sl      :=  TStringList.Create;
      s       :=  FCurrentBoard.CachePath + FCurrentBoard.BoardID + '.txt';
      sl.Add(FCurrentBoard.Name);
      for i :=  0 to  FThreadItemList.Count - 1 do  begin
        //Xbh
        sl.Add(
                FThreadItemList[i].Site.SiteID + #9 +
                FThreadItemList[i].BoardID + #9  +
                FThreadItemList[i].DatNo + #9  +
                FThreadItemList[i].Title + #9  +
                '1'
              );
      end;
      if  (FileExists(s)) then  begin
        CopyFile(PChar(s),
                 PChar(ChangeFileExt(s, '.bak')),
                 False);
      end;
      sl.SaveToFile(s);
      sl.Free;
    end;
  end;
  FModified :=  False;
end;

procedure TFavoritesEditor.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  SaveThreadList;
  ZonuEnviron.FavoritesSite.BoardList.SaveToFile(
                ZonuEnviron.FavoritesSite.ConfigPath + FILE_BOARD);
end;

procedure TFavoritesEditor.actFolderDeleteExecute(Sender: TObject);
var
  Site  : TSite;
  Board : TBoard;
begin
  if  (TreeView1.Selected <> nil) then  begin
    if  (TreeView1.Selected.Data <> nil)  then  begin
      if  (TObject(TreeView1.Selected.Data) is TBoard)  then  begin
        Board :=  TBoard(TreeView1.Selected.Data);
        Site  :=  ZonuEnviron.FavoritesSite;
        if  (DeleteBoard(Site, Board))  then  begin
          Site.LoadBoardList;
          BuildBoardList(TreeView1, Site);
          TreeView1.FullExpand;
        end;
      end;
    end;
  end;
end;

procedure TFavoritesEditor.actFolderEditExecute(Sender: TObject);
var
  Board : TBoard;
  Site  : TSite;
begin
  if  (TreeView1.Selected = nil)  then  begin
    Exit;
  end;
  Site  :=  ZonuEnviron.FavoritesSite;
  Board :=  nil;
  if  (TreeView1.Selected <> nil)  then  begin
    if  (TreeView1.Selected.Data =  nil)  then  begin
      Exit;
    end else begin
      Board :=  TBoard(TreeView1.Selected.Data);
    end;
  end;
  if  (Board.BoardType <> btFavorites)  then  begin
    MessageDlg('͏Cł܂B', mtError, [mbOk], 0);
    Exit;
  end;
  if  (EditBoard(Site, Board))  then  begin
    SaveBoardListSetting(TreeView1, Site);
    BuildBoardList(TreeView1, Site);
    TreeView1.FullExpand;
  end;
end;

procedure TFavoritesEditor.actFolderNewExecute(Sender: TObject);
var
  Board : TBoard;
  Site  : TSite;
  s, bn, path : string;
begin
  Site  :=  ZonuEnviron.FavoritesSite;
  s     :=  '';
  bn    :=  '';
  path  :=  '';
  if  (TreeView1.Selected <> nil)  then  begin
    if  (TreeView1.Selected.Data <> nil)  then  begin
      if  (TObject(TreeView1.Selected.Data) is TBoard)  then  begin
        Board :=  TBoard(TreeView1.Selected.Data);
        s     :=  Board.CategoryName;
        bn    :=  Board.Name;
        path  :=  Board.Url;
      end;
    end;
  end;
  if  (AddBoard(Site, s, bn, path)) then  begin
    SaveBoardListSetting(TreeView1, Site);
    BuildBoardList(TreeView1, Site);
    TreeView1.FullExpand;
  end;
end;

procedure TFavoritesEditor.Timer1Timer(Sender: TObject);
var
  i, n : integer;
begin
  Timer1.Enabled  :=  False;
  for i :=  0 to  dfsExtListView1.Columns.Count - 1  do  begin
    n :=  ZonuConfig.FavColumnWidth[i];
    if  (n > -1)  then  begin
      dfsExtListView1.Columns[i].Width :=  n;
    end;
  end;
end;

procedure TFavoritesEditor.actFolderMoveUpExecute(Sender: TObject);
var
  Site  : TSite;
  Board : TBoard;
  xBoard: TBoard;
  x : integer;
begin
  Site  :=  ZonuEnviron.FavoritesSite;
  if  (TreeView1.Selected <> nil) then  begin
    if  (TreeView1.Selected.Data <> nil)  then  begin
      if  (TObject(TreeView1.Selected.Data) is TBoard)  then  begin
        Board :=  nil;
        for x :=  0 to  Site.BoardList.Count - 1  do  begin
          if  (Site.BoardList[x] = TBoard(TreeView1.Selected.Data)) then  begin
            Board   :=  Site.BoardList[x];
            Break;
          end;
        end;
        if  (Board <> nil) and (x > 0)  then  begin
          xBoard  :=  Site.BoardList[x - 1];
          Board.CategoryName  :=  xBoard.CategoryName;
          Site.BoardList.Move(x, x - 1);
          Site.BoardList.SaveToFile(Site.ConfigPath + FILE_BOARD);
          BuildBoardList(TreeView1, Site);
          TreeView1.FullExpand;
        end;
      end;
    end;
  end;
  dfsExtListView1.Invalidate;
end;

procedure TFavoritesEditor.actFolderMoveDownExecute(Sender: TObject);
var
  Site  : TSite;
  Board : TBoard;
  xBoard: TBoard;
  x : integer;
begin
  Site  :=  ZonuEnviron.FavoritesSite;
  if  (TreeView1.Selected <> nil) then  begin
    if  (TreeView1.Selected.Data <> nil)  then  begin
      if  (TObject(TreeView1.Selected.Data) is TBoard)  then  begin
        Board :=  nil;
        for x :=  Site.BoardList.Count - 1 downto 0  do  begin
          if  (Site.BoardList[x] = TBoard(TreeView1.Selected.Data)) then  begin
            Board   :=  Site.BoardList[x];
            Break;
          end;
        end;
        if  (Board <> nil) and (x < Site.BoardList.Count - 1)  then  begin
          xBoard  :=  Site.BoardList[x + 1];
          Board.CategoryName  :=  xBoard.CategoryName;
          Site.BoardList.Move(x, x + 1);
          Site.BoardList.SaveToFile(Site.ConfigPath + FILE_BOARD);
          BuildBoardList(TreeView1, Site);
          TreeView1.FullExpand;
        end;
      end;
    end;
    dfsExtListView1.Invalidate;
  end;
end;

procedure TFavoritesEditor.dfsExtListView1StartDrag(Sender: TObject;
  var DragObject: TDragObject);
begin
  FListViewDragging  :=  True;
  FListViewX  :=  0;
  FListViewY  :=  0;
end;

procedure TFavoritesEditor.dfsExtListView1DragOver(Sender, Source: TObject;
  X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept      :=  (Sender = dfsExtListView1);
  FListViewX  :=  X;
  FListViewY  :=  Y;
end;

procedure TFavoritesEditor.dfsExtListView1DragDrop(Sender, Source: TObject;
  X, Y: Integer);
var
  DropItem  : TListItem;
  List  : TList;
  Index : integer;
  i, z : integer;
begin
  DropItem  :=  dfsExtListView1.GetItemAt(X, Y);
  if  (DropItem <> nil) then  begin
    Index   :=  DropItem.Index;
  end else
  if  (Y  > 0)  then  begin
    Index   :=  dfsExtListView1.Items.Count;
  end else begin
    Index   :=  -1;
  end;
  List  :=  TList.Create;
  for i :=  FThreadItemList.Count - 1 downto  0 do  begin
    if  (dfsExtListView1.Items[i].Selected) then  begin
      List.Add(FThreadItemList[i]);
      FThreadItemList.Erase(i);
      if (i < Index) then Dec(Index);
      dfsExtListView1.Items[i].Selected :=  False;
    end;
  end;
  dfsExtListView1.Selected  :=  nil;
  for i :=  0 to  List.Count  - 1 do  begin
    FThreadItemList.Insert(Index, List[i]);
  end;
  for i :=  0 to  FThreadItemList.Count  - 1 do  begin
    for z :=  0 to  List.Count - 1  do  begin
      if (FThreadItemList[i] = List[z]) then  begin
        dfsExtListView1.Items[i].Selected :=  True;
        Break;
      end;
    end;
  end;
  List.Free;
  dfsExtListView1.SetItemCountEx(FThreadItemList.Count ,[]);
  FModified :=  True;
end;

procedure TFavoritesEditor.TreeView1StartDrag(Sender: TObject;
  var DragObject: TDragObject);
begin
  FDragNode  :=  TreeView1.Selected;
end;

procedure TFavoritesEditor.TreeView1DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept  :=  (Source = dfsExtListView1)  or  (Source = TreeView1);
  if (GetKeyState(VK_SHIFT) < 0) then  begin
    TreeView1.DragCursor  :=  crMultiDrag;
  end else begin
    TreeView1.DragCursor  :=  crDrag;
  end;
end;

procedure TFavoritesEditor.TreeView1DragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
  Node          : TTreeNode;
  Site          : TSite;
  Board         : TBoard;
  ThreadItem    : TThreadItem;
  List: TList;
  sl: TStringList;
  i: integer;
  s: string;
begin
  if  (Source = dfsExtListView1)  then  begin
    Node        :=  TreeView1.GetNodeAt(X,Y);
    if  Node = nil  then  Exit;
    if  (Node = TreeView1.Selected)  then  Exit;

    if  (Node.Data <> nil)  then  begin
      if  (TObject(Node.Data) is TBoard)  then  begin
        if  (TBoard(Node.Data).BoardType = btFavorites) then  begin
          List  :=  TList.Create;
          for i :=  dfsExtListView1.Items.Count - 1 downto  0 do  begin
            if  (dfsExtListView1.Items[i].Selected)  then  begin
              List.Add(FThreadItemList[i]);
              DeleteFromFav(FThreadItemList[i]);
              FThreadItemList.Erase(i);
            end;
          end;
          //
          Board :=  TBoard(Node.Data);
          sl    :=  TStringList.Create;
          s     :=  Board.CachePath + Board.BoardID + '.txt';
          if  (FileExists(s)) then  begin
            sl.LoadFromFile(s);
          end else begin
            sl.Add(Board.Name);
          end;
          for i :=  List.Count - 1  downto  0  do  begin
            ThreadItem  :=  TThreadItem(List[i]);
            sl.Add(ThreadItem.Site.SiteID + #9 +
                   ThreadItem.BoardID + #9 +
                   ThreadItem.DatNo + #9 +
                   ThreadItem.Title + #9 +
                   '1');
            ThreadItem.InFavorites  :=  True;
            ThreadItem.SaveConfig;
            ThreadItem.ReleaseRef;
          end;
          sl.SaveToFile(s);
          sl.Free;
          List.Free;
          dfsExtListView1.SetItemCountEx(FThreadItemList.Count, []);
          FModified :=  True;
        end else begin
          Exit;
        end;
      end else begin
        Exit;
      end;
    end;
  end else begin
    //Cɓ̃hbv
    Site        :=  ZonuEnviron.FavoritesSite;
    Node        :=  TreeView1.GetNodeAt(X,Y);
    if  Node = nil  then  Exit;
    if  (FDragNode.Data <> nil) then  begin
      //
      //  ̈ړ
      //
      if  (TObject(Node.Data) is TBoard) then  begin
        //^[Qbg
        for i :=  0 to  Site.BoardList.Count - 1  do  begin
          if  (Site.BoardList[i]  =  TBoard(Node.Data)) then  begin
            for x :=  0 to  Site.BoardList.Count - 1  do  begin
              if  (Site.BoardList[x]  =  TBoard(FDragNode.Data)) then  begin
                Site.BoardList[x].CategoryName  :=  Site.BoardList[i].CategoryName;
                Site.BoardList.Move(x, i);
                BuildBoardList(TreeView1, ZonuEnviron.FavoritesSite);
                TreeView1.FullExpand;
                Break;
              end;
            end;
          end;
        end;
      end else begin
        //^[QbgȊO
        for i :=  0 to  Site.BoardList.Count - 1  do  begin
          if  (Site.BoardList[i]  =  TBoard(FDragNode.Data)) then  begin
            // FROM = i
            for x :=  Site.BoardList.Count - 1  downto  0  do  begin
              if  (Site.BoardList[x].CategoryName =  Node.Text) then  begin
                // TO = x
                Site.BoardList[i].CategoryName  :=  Node.Text;
                if  (i > x) then  begin
                  Site.BoardList.Move(i, x+1);
                end else begin
                  Site.BoardList.Move(i, x);
                end;
                BuildBoardList(TreeView1, ZonuEnviron.FavoritesSite);
                TreeView1.FullExpand;
                Break;
              end;
            end;
          end;
        end;
      end;
    end else begin
      //
      //  JeS̈ړ
      //
      if  (TObject(Node.Data) is TBoard) then  begin
        //^[Qbg
        for x :=  Site.BoardList.Count - 1  downto  0 do  begin
          if  (Site.BoardList[x].CategoryName = TBoard(Node.Data).CategoryName) then  begin
            for i :=  Site.BoardList.Count - 1  downto  0 do  begin
              if  (Site.BoardList[i].CategoryName = FDragNode.Text) then  begin
                if  (i > x) then  begin
                  Site.BoardList.Move(i, x+1);
                end else begin
                  Site.BoardList.Move(i, x);
                end;
              end;
            end;
            BuildBoardList(TreeView1, ZonuEnviron.FavoritesSite);
            TreeView1.FullExpand;
            Break;
          end;
        end;
      end else begin
        //^[QbgȊO
        for x :=  0 to  Site.BoardList.Count - 1  do  begin
          if  (Site.BoardList[x].CategoryName = Node.Text)  then  begin
            for i :=  Site.BoardList.Count - 1  downto  0 do  begin
              if  (Site.BoardList[i].CategoryName = FDragNode.Text) then  begin
                Site.BoardList.Move(i, x);
              end;
            end;
            BuildBoardList(TreeView1, ZonuEnviron.FavoritesSite);
            TreeView1.FullExpand;
            Break;
          end;
        end;
      end;
    end;
  end;
end;

procedure TFavoritesEditor.actPropertyExecute(Sender: TObject);
begin
  if  (dfsExtListView1.Selected <> nil) then  begin
    PropertyWindow  :=  TPropertyWindow.Create(Self);
    PropertyWindow.SetThreadItem(FThreadItemList[dfsExtListView1.Selected.Index]);
    if  (PropertyWindow.ShowModal = mrOk) then  begin
      dfsExtListView1.Invalidate;
    end;
    PropertyWindow.Release;
  end;
end;

procedure TFavoritesEditor.actMoveToLocalExecute(Sender: TObject);
var
  ThreadItem  : TThreadItem;
  i : integer;
begin
  LocalDialog :=  TLocalDialog.Create(Self);
  for i :=  FThreadItemList.Count - 1 downto  0 do  begin
    if  (dfsExtListView1.Items[i].Selected) then  begin
      LocalDialog.TargetList.Add(FThreadItemList[i]);
    end;
  end;
  if  (LocalDialog.ShowModal = mrOk) then  begin
    for i :=  FThreadItemList.Count - 1 downto  0 do  begin
      if  (dfsExtListView1.Items[i].Selected) then  begin
        ThreadItem  :=  FThreadItemList[i];
        DeleteFromFav(ThreadItem);
        ThreadItem.InFavorites  :=  False;
        ThreadItem.SaveConfig;
        ThreadItem.ReleaseRef;
        FThreadItemList.Delete(i);
      end;
    end;
  end;
  FModified :=  True;
  dfsExtListView1.SetItemCountEx(FThreadItemList.Count, []);
end;

procedure TFavoritesEditor.actWebEditUrlExecute(Sender: TObject);
var
  s : string;
begin
  if  (TreeView1.Selected <> nil) then  begin
    if  (TBoard(TreeView1.Selected.Data).BoardType = btWebPage) then  begin
      if  (Sender  =  actWebEditUrl)  then  begin
        s :=  TBoard(TreeView1.Selected.Data).Url;
        if  (InputQuery('ҏW', 'URL', S)) then  begin
          TBoard(TreeView1.Selected.Data).Url :=  s;
        end;
      end else begin
        s :=  TBoard(TreeView1.Selected.Data).Name;
        if  (InputQuery('ҏW', '^Cg', S)) then  begin
          TBoard(TreeView1.Selected.Data).Name  :=  s;
          TreeView1.Selected.Text :=  s;
        end;
      end;
    end
  end;
end;

procedure TFavoritesEditor.PopupMenu2Popup(Sender: TObject);
begin
  if  (TreeView1.Selected <> nil) then  begin
    actFolderMoveUp.Enabled   :=  (TreeView1.Selected.Level > 0);
    actFolderMoveDown.Enabled :=  (TreeView1.Selected.Level > 0);
    actFolderDelete.Enabled   :=  (TreeView1.Selected.Level > 0);
    actFolderEdit.Enabled     :=  (TreeView1.Selected.Level > 0);
  end else begin
    actFolderMoveUp.Enabled   :=  False;
    actFolderMoveDown.Enabled :=  False;
    actFolderDelete.Enabled   :=  False;
    actFolderEdit.Enabled     :=  False;
  end;
end;

end.
