{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 2channel Headline Window Unit                                     }
{                                                                             }
{ 2001-04 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Headline2ch;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Main, StdCtrls, ExtCtrls, Buttons, ShellApi, HttpProt, HTTPApp,
  ZonuConf, Hzbconst, ZonuClass;

type
  PHeadlineData = ^THeadlineData;
  THeadlineData = record
    Value : string;
    Category  : string;
    BoardName : string;
  end;

  THeadline2chDialog = class(TForm)
    Shape1: TShape;
    Image1: TImage;
    Label3: TLabel;
    ColorDialog1: TColorDialog;
    HttpCli1: THttpCli;
    HttpCli2: THttpCli;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Panel2: TPanel;
    Button1: TButton;
    Button2: TButton;
    Panel3: TPanel;
    ListView1: TListView;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure HttpCli1RequestDone(Sender: TObject; RqType: THttpRequest;
      Error: Word);
    procedure HttpCli2RequestDone(Sender: TObject; RqType: THttpRequest;
      Error: Word);
  private
    { Private 錾 }
    F2chSite: TSite;
    FHttpStream : TStringStream;
    FThreadItemList: TThreadItemList;
  public
    { Public 錾 }
    procedure Build;
    function  GetParamString: string;
    property  ThreadItemList: TThreadItemList read  FThreadItemList write FThreadItemList;
  end;

var
  Headline2chDialog: THeadline2chDialog;

implementation

{$R *.DFM}

uses
  MonaUtils, Zonutils;

procedure THeadline2chDialog.FormCreate(Sender: TObject);
begin
  FHttpStream  :=  TStringStream.Create('');
  ZonuEnviron.SiteList.FindSite('2ch', F2chSite);
end;

procedure THeadline2chDialog.FormDestroy(Sender: TObject);
begin
  FHttpStream.Free;
end;

procedure THeadline2chDialog.Build;
begin
  Screen.Cursor :=  crHourGlass;
  if  (ZonuConfig.ProxyUse) then  begin
    HttpCli1.Proxy          :=  ZonuConfig.Proxy;
    HttpCli1.ProxyPort      :=  ZonuConfig.ProxyPort;
    HttpCli1.ProxyUsername  :=  ZonuConfig.ProxyUserName;
    HttpCli1.ProxyPassword  :=  ZonuConfig.ProxyPassword;
  end;
  HttpCli1.Agent            :=  USER_AGENT;
  FHttpStream.Position      :=  0;
  FHttpStream.Size          :=  0;
  HttpCli1.RcvdStream       :=  FHttpStream;
  HttpCli1.URL              :=  ZonuConfig.Headline2chUrl;
  Button1.Enabled           :=  False;
  HttpCli1.GetASync;
end;

function THeadline2chDialog.GetParamString: string;
var
  i : integer;
  S : string;
  n : integer;
begin
  S :=  '';
  n :=  0;
  ZonuConfig.Fini.EraseSection('HEADLINE');
  for i :=  0 to  ListView1.Items.Count - 1 do  begin
    if  (ListView1.Items[i].Checked)  then  begin
      inc(n);
      if  (n > 5) then  begin
        Beep;
        MessageDlg('T𒴂Ă܂B', mtError, [mbOk], 0);
        Exit;
      end;
      if  (S <> '') then  S :=  S + '&';
      S :=  S + 'bbs=' + PHeadlineData(ListView1.Items[i].Data).Value;
      ZonuConfig.Fini.WriteString('2CH', 'HEADLINE_ITEM' + IntToStr(n),  PHeadlineData(ListView1.Items[i].Data).Value);
    end;
  end;
  Result  :=  S;

  ZonuConfig.Headline2chUrl       :=  HttpCli1.URL;
  //ZonuConfig.Headline2chPages     :=  CheckBox1.Checked;
  //ZonuConfig.Headline2chBoardName :=  CheckBox2.Checked;
  //ZonuConfig.Headline2chRank      :=  CheckBox3.Checked;
  //ZonuConfig.Headline2chBkColor   :=  Shape2.Brush.Color;
end;

procedure THeadline2chDialog.Image1Click(Sender: TObject);
begin
  ShellExecute(Handle, 'open', 'http://nmgm.s2.xrea.com/', '', '', SW_SHOW);
end;

procedure THeadline2chDialog.FormActivate(Sender: TObject);
begin
  Build;
end;

procedure THeadline2chDialog.HttpCli1RequestDone(Sender: TObject;
  RqType: THttpRequest; Error: Word);
var
  HeadlineData : PHeadlineData;
  CategoryName  : string;
  Item : TListItem;
  S : string;
  i, x : integer;
  sl : TStringList;
begin
  if  (HttpCli1.StatusCode = 200) then  begin
    CategoryName :=  '';
    sl  :=  TStringList.Create;
    sl.Text :=  FHttpStream.DataString;
    i :=  0;
    while true  do  begin
      if  (AnsiPos('<TD colSpan=5>', sl[i]) > 0)  then  begin
        //JeS
        s :=  Copy(sl[i], AnsiPos('<B>', sl[i]) + 3, Length(sl[i]));
        CategoryName  :=  Copy(s, 1, AnsiPos('</B>', s) - 1);
      end else
      if  (AnsiPos('<TD noWrap width="20%">', sl[i]) > 0)  then  begin
        //
        New(HeadlineData);
        HeadlineData.Category   :=  CategoryName;
        s :=  Copy(sl[i], AnsiPos('value=', sl[i]) + 6, Length(sl[i]));
        s :=  Copy(s, 1, AnsiPos(' ', s) - 1);
        HeadlineData.Value      :=  s;

        s :=  sl[i];
        if  (s[Length(s)] <> '>') then  begin
          inc(i);
        end;
        s :=  Copy(sl[i], AnsiPos(' name=bbs>', sl[i]) + 10, Length(sl[i]));
        s :=  Copy(s, 1, AnsiPos('</TD', s) - 1);
        HeadlineData.BoardName  :=  s;
        Item  :=  ListView1.Items.Add;
        Item.Caption  :=  HeadlineData.BoardName;
        Item.SubItems.Add(HeadlineData.Category);
        Item.Data         :=  HeadlineData;
        Item.ImageIndex   :=  1;
      end;
      inc(i);
      if  (i > sl.Count - 1)  then  Break;
    end;
    for i :=  0 to  4 do  begin
      S :=  ZonuConfig.Fini.ReadString('2ch' , 'HEADLINE_ITEM' + IntToStr(i + 1), '');
      if  (S <> '') then  begin
        for x :=  0 to  ListView1.Items.Count - 1 do  begin
          if  (PHeadlineData(ListView1.Items[x].Data).Value = s)  then  begin
            ListView1.Items[x].Checked  :=  True;
            Break;
          end;
        end;
      end;
    end;
    //CheckBox1.Checked   :=  ZonuConfig.Headline2chPages;
    //CheckBox2.Checked   :=  ZonuConfig.Headline2chBoardName;
    //CheckBox3.Checked   :=  ZonuConfig.Headline2chRank;
    //Shape2.Brush.Color  :=  ZonuConfig.Headline2chBkColor;
    Button1.Enabled     :=  True;
  end else begin
    MessageDlg(IntToStr(HttpCli1.StatusCode) + #13#10 + HttpCli1.ReasonPhrase, mtError, [mbOk], 0);
  end;
  Screen.Cursor       :=  crDefault;
  HotzonuWindow.EndProc;
end;

procedure THeadline2chDialog.BitBtn1Click(Sender: TObject);
var
  Source  : TStringStream;
  s : string;
begin
  S           :=  GetParamString + '&submit='  + HTTPEncode('M');
  Source      :=  TStringStream.Create(S);
  if  (ZonuConfig.ProxyUse) then  begin
    HttpCli2.Proxy          :=  ZonuConfig.Proxy;
    HttpCli2.ProxyPort      :=  ZonuConfig.ProxyPort;
    HttpCli2.ProxyUsername  :=  ZonuConfig.ProxyUserName;
    HttpCli2.ProxyPassword  :=  ZonuConfig.ProxyPassword;
  end;
  FHttpStream.Position      :=  0;
  FHttpStream.Size          :=  0;
  HttpCli2.RcvdStream       :=  FHttpStream;
  HttpCli2.SendStream       :=  Source;
  HttpCli2.URL              :=  ZonuConfig.Headline2chExecUrl;
  HttpCli2.Agent            :=  USER_AGENT;
  Button1.Enabled           :=  False;
  Screen.Cursor :=  crHourGlass;
  HotzonuWindow.Memo1.Lines.Add('Q˂wbhCɐڑł...');
  HotzonuWindow.StartProc;
  HttpCli2.PostASync;
end;



procedure THeadline2chDialog.HttpCli2RequestDone(Sender: TObject;
  RqType: THttpRequest; Error: Word);
var
  n, br, m : integer;
  s, sx, sy : string;
  ThreadItem  : TThreadItem;
  No : integer;
  Board : TBoard;
  Url, DatUrl : string;
  ASubject  : string;
  ACount    : integer;
  OldUrl    : string;
  BoardID   : string;
  cn: string;
begin
  if  (HttpCli1.StatusCode = 200) then  begin
    HotzonuWindow.Memo1.Lines.Add('Q˂wbhCMł...');
    S :=  FHttpStream.DataString;
    S :=  StringReplace(S, #13#10, #10, [rfReplaceAll]);
    S :=  StringReplace(S, #10, #13#10, [rfReplaceAll]);
    No:=  0;
    cn:=  '';
    while true  do  begin
      //h1  :=  AnsiPos('<h1>', AnsiLowerCase(S));
      br  :=  AnsiPos('<br>',  AnsiLowerCase(S));
      if  (br = 0)  then  Break;
      //if  (h1 < br) and (h1 > 0)  then  begin
      //  S   :=  Copy(S, h1 + 4, Length(S));
      //  No  :=  0;
        {
        BoardName   :=  Copy(S, 1, AnsiPos('</h1>', AnsiLowerCase(S)) - 1);
        ThreadItem        :=  TThreadItem.Create;
        ThreadItem.Title  :=  BoardName;
        ThreadItemList.Add(ThreadItem);
        }
      //end else begin
        S     :=  Copy(S, br + 3, Length(S));
        S     :=  Copy(S, AnsiPos('<a href="', S), Length(S));
        Url   :=  Copy(S, 10, AnsiPos('" target="', S) - 11);
        S     :=  Copy(S, AnsiPos('>', S) + 1, Length(S));
        sx    :=  Copy(S, 1, AnsiPos('</a>', S) - 1);
        sy    :=  sx;
        n     :=  0;
        while true  do  begin
          m :=  AnsiPos('(', sy);
          if  (m < 1) then  Break;
          n   :=  n + m;
          sy  :=  Copy(sy, n + 1, Length(sy));
        end;
        ASubject  :=  Copy(sx, 1, n - 1);
        ACount    :=  StrToIntDef(Copy(sx, n + 1, Length(sx) - 1 - n), 0);

        if  (Url <> '') and (AnsiPos('../', Url) = 0) then  begin
          DatUrl  :=  NichCgiUrlToDatUrl(Url);
          OldUrl  :=  F2chSite.BBS.ConvUrl(Url);
          BoardID :=  ChooseValue(OldUrl, 'bbs');
          if  (F2chSite.BoardList.FindBoard(BoardID, Board))  then  begin
            ThreadItem        :=  TThreadItem.Create;
            //ThreadItem.Board  :=  Board;
            ThreadItem.CreateThreadItem(Board.Site.SiteID,
                                        Board.BoardID,
                                        ExtractDatNo(ExtractUrlName(DatUrl)),
                                        Trim(ASubject));
            ThreadItem.BBS    :=  Board.BBS;
            ThreadItem.Site   :=  Board.Site;
            ThreadItem.LoadConfig;
            if  (cn <>  Board.BoardID) then  begin
              No  :=  0;
              cn  :=  Board.BoardID;
            end;
            ThreadItem.No         :=  No + 1;
            if  (ThreadItem.AgeCount > ACount)  then  begin
              ThreadItem.Updated  :=  True;
            end;
            ThreadItem.AgeCount   :=  ACount;
            ThreadItemList.Add(ThreadItem);
            inc(No);
          end;
        end;
      //end;
    end;
  end else begin
    MessageDlg(IntToStr(HttpCli1.StatusCode) + #13#10 + HttpCli1.ReasonPhrase, mtError, [mbOk], 0);
  end;
  Screen.Cursor :=  crDefault;
  HotzonuWindow.EndProc;
  ModalResult :=  mrOk;
end;

end.
