{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Tool Dialog Unit                                                  }
{                                                                             }
{ 2001-04 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Tooldlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, ExtCtrls, Dlghead;

type
  TToolDialog = class(TForm)
    Label1: TLabel;
    ListBox1: TListBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Button4: TButton;
    HeaderFrame1: THeaderFrame;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private 錾 }
    FToolConfig : TStringList;
  public
    { Public 錾 }
  end;

var
  ToolDialog: TToolDialog;

implementation

{$R *.DFM}

uses
  Hzbconst, ZonuConf, MonaUtils, Zonutils, Tooledt;

function BoolToStr(const b: boolean): string;
begin
  if  (b) then  begin
    Result  :=  '1';
  end else begin
    Result  :=  '0';
  end;
end;

procedure TToolDialog.FormCreate(Sender: TObject);
var
  i : integer;
begin
  FToolConfig :=  TStringList.Create;
  if  (FileExists(ZonuConfig.UsersPath + FILE_TOOL))  then  begin
    FToolConfig.LoadFromFile(ZonuConfig.UsersPath + FILE_TOOL);
    for i :=  0 to  FToolConfig.Count - 1 do  begin
      ListBox1.Items.Add(ChooseString(FToolConfig[i], #9, 0));
    end;
  end;
end;

procedure TToolDialog.FormDestroy(Sender: TObject);
begin
  FToolConfig.Free;
end;

procedure TToolDialog.Button2Click(Sender: TObject);
begin
  if  (ListBox1.ItemIndex > -1) then  begin
    FToolConfig.Delete(ListBox1.ItemIndex);
    ListBox1.Items.Delete(ListBox1.ItemIndex);
    if  (ListBox1.Items.Count > 0) then  begin
      ListBox1.ItemIndex  :=  0;
    end;
  end;
end;

procedure TToolDialog.SpeedButton1Click(Sender: TObject);
var
  a : integer;
begin
  if  (ListBox1.ItemIndex > -1) then  begin
    if  (ListBox1.ItemIndex > 0)  then  begin
      a :=  ListBox1.ItemIndex;
      FToolConfig.Move(ListBox1.ItemIndex, ListBox1.ItemIndex - 1);
      ListBox1.Items.Move(ListBox1.ItemIndex, ListBox1.ItemIndex - 1);
      ListBox1.SetFocus;
      ListBox1.ItemIndex  := a - 1;
    end;
  end;
end;

procedure TToolDialog.SpeedButton2Click(Sender: TObject);
var
  a : integer;
begin
  if  (ListBox1.ItemIndex > -1) then  begin
    if  (ListBox1.ItemIndex < ListBox1.Items.Count - 1)  then  begin
      a :=  ListBox1.ItemIndex;
      FToolConfig.Move(ListBox1.ItemIndex, ListBox1.ItemIndex + 1);
      ListBox1.Items.Move(ListBox1.ItemIndex, ListBox1.ItemIndex + 1);
      ListBox1.SetFocus;
      ListBox1.ItemIndex  := a + 1;
    end;
  end;
end;

procedure TToolDialog.Button1Click(Sender: TObject);
var
  s : string;
begin
  ToolEditDialog  :=  TToolEditDialog.Create(Self);
  if  (ToolEditDialog.ShowModal = mrOk) then  begin
    S :=  ToolEditDialog.Title + #9 +
          ToolEditDialog.FilePath + #9 +
          ToolEditDialog.WorkDir + #9 +
          ToolEditDialog.Params + #9 +
          BoolToStr(ToolEditDialog.ParamUrl);
    FToolConfig.Add(S);
    ListBox1.Items.Add(ToolEditDialog.Title);
  end;
  ToolEditDialog.Free;
end;

procedure TToolDialog.ListBox1Click(Sender: TObject);
begin
  Button2.Enabled :=  (ListBox1.Items.Count > 0);
  Button3.Enabled :=  (ListBox1.Items.Count > 0);
  SpeedButton1.Enabled :=  (ListBox1.Items.Count > 1);
  SpeedButton2.Enabled :=  (ListBox1.Items.Count > 1);
end;

procedure TToolDialog.Button3Click(Sender: TObject);
var
  s : string;
begin
  if  (ListBox1.ItemIndex > -1) then  begin
    s :=  FToolConfig[ListBox1.ItemIndex];
    ToolEditDialog  :=  TToolEditDialog.Create(Self);
    ToolEditDialog.Title    :=  ChooseString(s, #9, 0);
    ToolEditDialog.FilePath :=  ChooseString(s, #9, 1);
    ToolEditDialog.WorkDir  :=  ChooseString(s, #9, 2);
    ToolEditDialog.Params   :=  ChooseString(s, #9, 3);
    ToolEditDialog.ParamUrl :=  (ChooseString(s, #9, 4) = '1');
    if  (ToolEditDialog.ShowModal = mrOk) then  begin
      S :=  ToolEditDialog.Title + #9 +
            ToolEditDialog.FilePath + #9 +
            ToolEditDialog.WorkDir + #9 +
            ToolEditDialog.Params + #9 +
            BoolToStr(ToolEditDialog.ParamUrl);
      FToolConfig[ListBox1.ItemIndex] :=  S;
      ListBox1.Items[ListBox1.ItemIndex]  :=  ToolEditDialog.Title;
    end;
    ToolEditDialog.Free;
  end;
end;

procedure TToolDialog.Button4Click(Sender: TObject);
begin
  Close;
end;

procedure TToolDialog.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  FToolConfig.SaveToFile(ZonuConfig.UsersPath + FILE_TOOL);
end;

end.
