{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Tool Dialog Unit                                                  }
{                                                                             }
{ 2001-04 www.monazilla.org Dax mailto:daxmonazilla@yahoo.co.jp               }
{                                                                             }
{ *************************************************************************** }

unit Tooledt;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, FileCtrl;

type
  TToolEditDialog = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    Label4: TLabel;
    Edit4: TEdit;
    SpeedButton1: TSpeedButton;
    OpenDialog1: TOpenDialog;
    CheckBox1: TCheckBox;
    Button1: TButton;
    Button2: TButton;
    procedure SpeedButton1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    function GetFilePath: string;
    function GetTitle: string;
    procedure SetFilePath(const Value: string);
    procedure SetTitle(const Value: string);
    function GetParams: string;
    procedure SetParams(const Value: string);
    function GetWorkDir: string;
    procedure SetWorkDir(const Value: string);
    function GetParamUrl: boolean;
    procedure SetParamUrl(const Value: boolean);
    { Private 錾 }
  public
    { Public 錾 }
    property  Title: string       read  GetTitle    write SetTitle;
    property  FilePath: string    read  GetFilePath write SetFilePath;
    property  Params: string      read  GetParams   write SetParams;
    property  WorkDir: string     read  GetWorkDir  write SetWorkDir;
    property  ParamUrl: boolean   read  GetParamUrl write SetParamUrl;
  end;

var
  ToolEditDialog: TToolEditDialog;

implementation

{$R *.DFM}

{ TToolEditDialog }

function TToolEditDialog.GetFilePath: string;
begin
  Result  :=  Edit2.Text;
end;

function TToolEditDialog.GetParams: string;
begin
  Result  :=  Edit4.Text;
end;

function TToolEditDialog.GetTitle: string;
begin
  Result  :=  Edit1.Text;
end;

function TToolEditDialog.GetWorkDir: string;
begin
  Result  :=  Edit3.Text;
end;

procedure TToolEditDialog.SetFilePath(const Value: string);
begin
  Edit2.Text  :=  Value;
end;

procedure TToolEditDialog.SetParams(const Value: string);
begin
  Edit4.Text  :=  Value;
end;

procedure TToolEditDialog.SetTitle(const Value: string);
begin
  Edit1.Text  :=  Value;
end;

procedure TToolEditDialog.SetWorkDir(const Value: string);
begin
  Edit3.Text  :=  Value;
end;

procedure TToolEditDialog.SpeedButton1Click(Sender: TObject);
begin
  OpenDialog1.FileName  :=  Edit2.Text;
  if  (OpenDialog1.Execute) then  begin
    Edit2.Text  :=  OpenDialog1.FileName;
    if  (Edit1.Text = '') then  begin
      Edit1.Text  :=  Copy(ExtractFileName(OpenDialog1.FileName), 1, Length(ExtractFileName(OpenDialog1.FileName)) - Length(ExtractFileExt(OpenDialog1.FileName)));
    end;
  end;
end;

procedure TToolEditDialog.BitBtn1Click(Sender: TObject);
begin
  if  (Trim(Edit1.Text) = '') then  begin
    Beep;
    Edit1.SetFocus;
  end else
  if  (Trim(Edit2.Text) = '') then  begin
    Beep;
    Edit2.SetFocus;
  end else
  if  (not FileExists(Edit2.Text)) then  begin
    Beep;
    MessageDlg('vO܂łB', mtError, [mbOk], 0);
    Edit2.SetFocus;
  end else
  if  (Edit3.Text <>'') and (not DirectoryExists(Edit3.Text)) then  begin
    //thx
    Beep;
    MessageDlg('tH_܂łB', mtError, [mbOk], 0);
    Edit3.SetFocus;
  end else begin
    ModalResult :=  mrOk;
  end;
end;

function TToolEditDialog.GetParamUrl: boolean;
begin
  Result  :=  CheckBox1.Checked;
end;

procedure TToolEditDialog.SetParamUrl(const Value: boolean);
begin
  CheckBox1.Checked :=  Value;
end;

end.
