{ *************************************************************************** }
{                                                                             }
{ Hotzonu Local Script Unit                                                    }
{                                                                             }
{ 2001-04 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit ZonuLocal;

interface

uses
  Classes, SysUtils, Forms, IniFiles, ZonuClass, ZonuCommon, ZonuHttp, Hzbconst;

type
  PParamData  = ^TParamData;
  TParamData  = record
    //
  end;

  TLocalScript = class(TBBS)
  private
    { private }
  protected
    { protected }
    function  GetThreadListType: TThreadListAccessType; override;
    function GetThreadDownloadMode: TThreadDownloadMode; override;
    function GetNeedHRefLink: boolean; override;
    function GetNeedLinkTarget: boolean; override;
    function GetRelativeLink: boolean; override;
    function GetIsPublished: boolean; override;
    procedure ZonuDataThreadList(Sender: TObject; Downloader: TDownloader;
      Data: string; TotalSize, DownloadSize: integer; var MoreData: boolean); override;
    procedure ZonuEndThreadList(Sender: TObject; Downloader: TDownloader;
      Error: boolean); override;
    procedure ZonuThreadListError(Sender: TObject; Downloader: TDownloader;
      ErrorCode: integer; ErrorMsg: string); override;
    procedure ZonuDataRes(Sender: TObject; Downloader: TDownloader;
      Data: string; TotalSize, DownloadSize: integer; var MoreData: boolean); override;
    procedure ZonuEndRes(Sender: TObject; Downloader: TDownloader;
      Error: boolean); override;
    procedure ZonuResError(Sender: TObject; Downloader: TDownloader;
      ErrorCode: integer; ErrorMsg: string); override;
  public
    { public }
    constructor Create(const ABBSID: string); override;
    procedure ParseSubject(subject: string; out FileName: string;
      out Title: string; out Count: integer); override;
    procedure ParseDat(const ALine: string; const index: integer;
      var ARes: TRes; out ASubject: string); override;
    procedure DownloadThreadList(Downloader: TThreadListDownloader;
      const NoCache, ASync, InfSave: boolean); override;
    procedure DownloadThreadItem(Downloader: TResDownloader;
      const NoCache, ASync, InfSave, AutoPilot: boolean); override;
    procedure SendRes(Uploader: TResUploader); override;
    procedure SendThread(Uploader: TThreadUploader); override;
    function  GetDisplayUrl(ThreadItem: TThreadItem): string; override;
  end;

implementation

uses
  Zonutils, ZonuConf, MonaUtils;

{ TLocalScript }

//
//  Xbhꗗ̎擾@
//
function TLocalScript.GetThreadListType: TThreadListAccessType;
begin
  Result  :=  tlLump;
end;

//
//  Xbh̎擾@
//
function TLocalScript.GetThreadDownloadMode: TThreadDownloadMode;
begin
  Result  :=  dmText;
end;

//
//  http://ւ̃Nǉ
//
function TLocalScript.GetNeedHRefLink: boolean;
begin
  Result  :=  True;
end;

//
//  NւTarget=_blankǉ
//
function TLocalScript.GetNeedLinkTarget: boolean;
begin
  Result  :=  False;
end;

//
//  BBSEBU[hŕ\邩ǂ
//
function TLocalScript.GetIsPublished: boolean;
begin
  Result  :=  False;
end;

//
//  Xbhꗗ_E[h
//
procedure TLocalScript.DownloadThreadList(Downloader: TThreadListDownloader;
  const NoCache, ASync, InfSave: boolean);
var
  ThreadItem  : TThreadItem;
  Board       : TBoard;
  MoreData    : boolean;
  Rec : TSearchRec;
  sl  : TStringList;
  ini : TMemIniFile;
  DatNo   : string;
  n : integer;
  s : string;
begin
  sl        :=  TStringList.Create;
  Board     :=  Downloader.Board;
  Board.Url :=  IncludeTrailingPathDelimiter(Board.Url);
  n :=  1;
  if  (FindFirst(Board.Url + '*.dat', faAnyFile, Rec) = 0) then  begin
    repeat
      //26 begin
      {
      if  (AnsiLowerCase(Rec.Name) <> 'subject.dat')  then  begin
        sl.LoadFromFile(Board.Url + Rec.Name);
        if  (sl.Count > 0)  then  begin
          s :=  ChooseString(sl[0], '<>', 4);
          DatNo :=  Copy(Rec.Name, 1, AnsiPos('.dat', Rec.Name) - 1);
          ThreadItem        :=  TThreadItem.Create;
          ThreadItem.CreateThreadItem(Board.Site.SiteID,
                                      Board.BoardID,
                                      DatNo,
                                      s
                                      );
          ThreadItem.LocalDatFileName :=  Board.Url + Rec.Name;
          ThreadItem.AgeCount         :=  sl.Count;
          ThreadItem.No               :=  n;
          ThreadItem.BBS              :=  Self;
          ThreadItem.Site             :=  Downloader.Site;
          ThreadItem.BoardID          :=  Downloader.Board.BoardID;
          ThreadItem.InLocalFolder    :=  True;
          Inc(n);
          Downloader.FireDataEvt(ThreadItem, 0, 0, MoreData);
        end;
      end;
      }
      if  (AnsiLowerCase(Rec.Name) <> 'subject.dat')  then  begin
        if  (FileExists(ChangeFileExt(Rec.Name, '.inf')))  then  begin
          ini :=  TMemIniFile.Create(Board.Url + ChangeFileExt(Rec.Name, '.inf'));
          s   :=  ini.ReadString('LOG', 'TITLE', '');
          ini.Free;
        end else begin
          sl.LoadFromFile(Board.Url + Rec.Name);
          if  (sl.Count > 0)  then  begin
            s :=  ChooseString(sl[0], '<>', 4);
          end else begin
            s :=  '';
          end;
        end;

        DatNo :=  Copy(Rec.Name, 1, AnsiPos('.dat', Rec.Name) - 1);
        ThreadItem        :=  TThreadItem.Create;
        ThreadItem.CreateThreadItem(Board.Site.SiteID,
                                    Board.BoardID,
                                    DatNo,
                                    s
                                    );
        ThreadItem.LocalDatFileName :=  Board.Url + Rec.Name;
        ThreadItem.AgeCount         :=  sl.Count;
        ThreadItem.No               :=  n;
        ThreadItem.BBS              :=  Self;
        ThreadItem.Site             :=  Downloader.Site;
        ThreadItem.BoardID          :=  Downloader.Board.BoardID;
        ThreadItem.InLocalFolder    :=  True;
        Inc(n);
        Downloader.FireDataEvt(ThreadItem, 0, 0, MoreData);

      end;
      //26 end
    until (FindNext(Rec) <> 0);
  end;
  sl.Free;
  ZonuEndThreadList(Self, Downloader, False);
end;

//
//  Xbhꗗ擾
//
procedure TLocalScript.ZonuDataThreadList(Sender: TObject;
  Downloader: TDownloader; Data: string; TotalSize,
  DownloadSize: integer; var MoreData: boolean);
begin
  //
end;

//
//  Xbhꗗ擾I
//
procedure TLocalScript.ZonuEndThreadList(Sender: TObject;
  Downloader: TDownloader; Error: boolean);
var
  ParamData:  PParamData;
begin
  ParamData :=  PParamData(Downloader.ParamData);
  Dispose(ParamData);
  inherited;
end;

//
//  Xbhꗗ擾G[
//
procedure TLocalScript.ZonuThreadListError(Sender: TObject;
  Downloader: TDownloader; ErrorCode: integer; ErrorMsg: string);
begin
  inherited;

end;

//
//  Xbhꗗ̉
//
procedure TLocalScript.ParseSubject(subject: string; out FileName,
  Title: string; out Count: integer);
begin
  inherited;
  Parse2chSubject(subject, FileName, Title, Count);
end;

//
//  X̉
//
procedure TLocalScript.ParseDat(const ALine: string; const index: integer;
  var ARes: TRes; out ASubject: string);
begin
  inherited;
  Parse2chDat(ALine, Index, ARes, ASubject);
end;


//
//  \URL
//
function TLocalScript.GetDisplayUrl(ThreadItem: TThreadItem): string;
var
  ini: TMemIniFile;
  ABoardID, ASiteID: string;
  AThreadItem: TThreadItem;
begin
  //Result  :=  ThreadItem.RemoteDatFileName;
  ini       :=  TMemIniFile.Create(ChangeFileExt(ThreadItem.LocalDatFileName, '.inf'));
  ABoardID  :=  ini.ReadString('ORG', 'BOARDID', '');
  ASiteID   :=  ini.ReadString('ORG', 'SITEID', '');
  AThreadItem   :=  TThreadItem.Create;
  if  (AThreadItem.CreateThreadItem(ASiteID,
                                    ABoardID,
                                    ThreadItem.DatNo,
                                    ThreadItem.Title)) then
  begin
    Result  :=  AThreadItem.BBS.GetDisplayUrl(AThreadItem);
  end else begin
    Result  :=  '???';
  end;
  AThreadItem.ReleaseRef;
  ini.Free;
end;

//
//  Xbh̃_E[h
//
procedure TLocalScript.DownloadThreadItem(Downloader: TResDownloader;
  const NoCache, ASync, InfSave, AutoPilot: boolean);
begin
  Downloader.NotModified  :=  True;
  Downloader.HttpObj      :=  nil;
  while (not Downloader.CacheReady) do  begin
    Sleep(500);
    Application.ProcessMessages;
    if  (ZonuEnviron.Disconnected)  then  begin
      raise EZonuError.Create('ؒf܂B');
    end;
  end;
  ZonuEndRes(Self, Downloader, False);
end;

//
//  X擾
//
procedure TLocalScript.ZonuDataRes(Sender: TObject;
  Downloader: TDownloader; Data: string; TotalSize, DownloadSize: integer;
  var MoreData: boolean);
begin
  //
end;

//
//  X擾I
//
procedure TLocalScript.ZonuEndRes(Sender: TObject; Downloader: TDownloader;
  Error: boolean);
begin
  //
  inherited;
end;

//
//  X擾G[
//
procedure TLocalScript.ZonuResError(Sender: TObject;
  Downloader: TDownloader; ErrorCode: integer; ErrorMsg: string);
begin
  inherited;

end;

procedure TLocalScript.SendRes(Uploader: TResUploader);
var
  s: string;
  sl: TStringList;
  sd: TSendData;
  sa, sb : string;
begin
  s   :=  Uploader.ThreadItem.LocalDatFileName;
  sd  :=  Uploader.SendData;
  sl  :=  TStringList.Create;
  sl.LoadFromFile(s);
  if  (sd.Pre)  then  begin
    sa  :=  sa + '<PRE>';
    sb  :=  sb + '</PRE>';
  end;
  if  (sd.Touhaba)  then  begin
    sa  :=  sa + '<TT>';
    sb  :=  sb + '</TT>';
  end;
  sl.Add(Format('%s<>%s<>%s<>%s<>%s<>',
                [EncodeHtmlEsc(sd.Name),
                 EncodeHtmlEsc(sd.Mail),
                 EncodeHtmlEsc(FormatDateTime('yy/mm/dd hh:nn', Now)),
                 sa + EncodeHtmlEsc(sd.Body) + sb,
                 ''
                 ]));
  sl.SaveToFile(s);
  sl.Free;
  Uploader.FireEndUpload(False);
end;

procedure TLocalScript.SendThread(Uploader: TThreadUploader);
var
  s: string;
  sl: TStringList;
  sd: TSendData;
  sa, sb : string;
begin
  s   :=  Uploader.Board.CachePath + Get2chDate(Now) + '.dat';
  sd  :=  Uploader.SendData;
  sl  :=  TStringList.Create;
  sa  :=  '';
  sb  :=  '';
  if  (sd.Pre)  then  begin
    sa  :=  sa + '<PRE>';
    sb  :=  sb + '</PRE>';
  end;
  if  (sd.Touhaba)  then  begin
    sa  :=  sa + '<TT>';
    sb  :=  sb + '</TT>';
  end;
  sl.Add(Format('%s<>%s<>%s<>%s<>%s<>',
                [EncodeHtmlEsc(sd.Name),
                 EncodeHtmlEsc(sd.Mail),
                 EncodeHtmlEsc(FormatDateTime('yy/mm/dd hh:nn', Now)),
                 sa + EncodeHtmlEsc(sd.Body) + sb,
                 EncodeHtmlEsc(sd.Subject)
                 ]));
  sl.SaveToFile(s);
  sl.Free;
  Uploader.FireEndUpload(False);
end;

function TLocalScript.GetRelativeLink: boolean;
begin
  Result  :=  False;
end;

constructor TLocalScript.Create(const ABBSID: string);
begin
  inherited;
  Include(FSendOption, soPre);
  Include(FSendOption, soTouhaba);
  Include(FNewThreadOption, soPre);
  Include(FNewThreadOption, soTouhaba);
end;

end.
