{ *************************************************************************** }
{                                                                             }
{ Hotzonu Web Unit                                                            }
{                                                                             }
{ 2001-05 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit ZonuWeb;

interface

uses
  Classes, SysUtils, IniFiles, ZonuClass, ZonuCommon, ZonuHttp, Hzbconst,
  Gikobas, ZonuCustom;

type
  TWebScript = class(TCustomScript)
  private
    { private }
  protected
    { protected }
    function GetWebRedirect: boolean; override;
  public
    { public }
    procedure DownloadThreadList(Downloader: TThreadListDownloader;
      const NoCache, Async, InfSave: boolean); override;
    procedure ZonuDataThreadList(Sender: TObject; Downloader: TDownloader;
      Data: string; TotalSize, DownloadSize: integer; var MoreData: boolean); override;
    procedure DownloadThreadItem(Downloader: TResDownloader;
      const NoCache, Async, InfSave, AutoPilot: boolean); override;
    function  GetDisplayUrl(ThreadItem: TThreadItem): string; override;
  end;

implementation

{ TWebScript }

uses
  MonaUtils;

procedure TWebScript.DownloadThreadList(Downloader: TThreadListDownloader;
  const NoCache, Async, InfSave: boolean);
begin
  ParseThreadSource :=  Downloader.Site.ConfigPath + FILE_PARSE_THREAD;
  inherited DownloadThreadList(Downloader, True, ASync, InfSave);
end;

//
//  Xbhꗗ擾
//
procedure TWebScript.ZonuDataThreadList(Sender: TObject;
  Downloader: TDownloader; Data: string; TotalSize,
  DownloadSize: integer; var MoreData: boolean);
var
  dl        : TThreadListDownloader;
  ThreadItem: TThreadItem;
  FGikoBas  : TGikoBas;
begin
  dl  :=  TThreadListDownloader(Downloader);
  FGikoBas  :=  PParamData(dl.ParamData).GikoBas;
  FGikoBas.AddVar('Data',       Data);
  FGikoBas.AddVar('ParseOk',    False);
  FGikoBas.AddVar('ParseOk',    False);
  FGikoBas.AddVar('TempData',   dl.Temp);
  FGikoBas.AddVar('OK',         True);
  FGikoBas.exec;
  if  (FGikoBas.GetVar('ParseOk'))  then  begin
    if (FGikoBas.GetVar('DatName') <> '') then  begin
      ThreadItem                    :=  TThreadItem.Create;
      ThreadItem.BBS                :=  Self;
      ThreadItem.Site               :=  dl.Site;
      ThreadItem.BoardID            :=  dl.Board.BoardID;
      ThreadItem.No                 :=  0;
      ThreadItem.DatFileName        :=  ExtractUrlName(FGikoBas.GetVar('DatName'));
      ThreadItem.Title              :=  FGikoBas.GetVar('ThreadTitle');
      ThreadItem.AgeCount           :=  1; //StrToIntDef(FGikoBas.GetVar('ResCount'), 0);
      ThreadItem.RemoteDatFileName  :=  FGikoBas.GetVar('DatName');
      ThreadItem.LocalDatFileName   :=  dl.Board.CachePath + ThreadItem.DatFileName;
      dl.FireDataEvt(ThreadItem, DownloadSize, TotalSize, MoreData);
      FGikoBas.AddVar('DatName',    '');
      FGikoBas.AddVar('ThreadTitle','');
      FGikoBas.AddVar('ResCount',   '');
    end;
  end;
  dl.Temp := FGikoBas.GetVar('TempData');
end;

function TWebScript.GetDisplayUrl(ThreadItem: TThreadItem): string;
begin
  Result  :=  ThreadItem.DatFileName;
end;

procedure TWebScript.DownloadThreadItem(Downloader: TResDownloader;
  const NoCache, Async, InfSave, AutoPilot: boolean);
var
  ThreadItem: TThreadItem;
  inf: TMemIniFile;
  s: string;
begin
  ThreadItem := TResDownloader(Downloader).ThreadItem;
  if  (ZonuEnviron.Cached)  and (not Downloader.NotModified) then  begin
    s :=  ExtractFilePath(ThreadItem.LocalDatFileName);
    if  (not DirectoryExists(s)) and (s <> '')  then  begin
      ForceDirectories(s);
    end;
    //
    if  (s <> '') then  begin
      ThreadItem.LastLoadDate :=  FormatDateTime('yyyy/mm/dd hh:nn:ss', Now);
      inf :=  TMemIniFile.Create(ChangeFileExt(ThreadItem.LocalDatFileName, '.inf'));
      inf.WriteInteger('LOG', 'COUNT', ThreadItem.DownloadCount);
      inf.WriteString('LOG', 'TITLE', ThreadItem.Title);
      inf.WriteString('LOG', 'BOARDID', ThreadItem.BoardID);
      inf.WriteString('LOG', 'LAST_LOAD', ThreadItem.LastLoadDate);
      inf.UpdateFile;
      inf.Free;
    end;
  end;
  Downloader.FireRedirect(ThreadItem.RemoteDatFileName);
  Downloader.FireEndDownload(False);
end;

function TWebScript.GetWebRedirect: boolean;
begin
  Result  :=  True;
end;

end.
