
{*******************************************************}
{                                                       }
{       HotZonu Utnilities Unit                         }
{                                                       }
{       monazilla.org (w software foundation 2001       }
{                                                       }
{*******************************************************}

unit Zonutils;

interface

uses
  SysUtils, Classes, HTTPApp, ShellApi, Windows, Menus, Graphics, DateUtils,
  MonaUtils, Hzbconst;

type
	TStrTokSeparator = set of Char;
	TStrTokRec = record
		Str: string;
		Pos: Integer;
	end;
  
  function GetFileDate(FileName: String): TDateTime;  {from monaCommonFunc/turbo type D}
  function DateTimeNearEqual(A, B: TDateTime; Second: word): Boolean; {from monaCommonFunc/turbo type D}
  procedure DivideNichSubject(subject: string; var FileName: string; var Title: string; var Count: integer); {Gikonavi}
  procedure DivideShitaSubject(subject: string; var FileName: string; var Title: string; var Count: integer);
  function StrTokFirst(const s:string; const sep:TStrTokSeparator; var Rec:TStrTokRec):string; {GikoNavi}
  function StrTokNext(const sep:TStrTokSeparator; var Rec:TStrTokRec): string; {GikoNavi}
  function NichCgiUrlToDatUrl(const Url: string): string;
  function GetShortTitle(const LongName: string; ALength: integer): string;
  //function PickupKakoUrl(const Content, DatNo: string): string;
  function ShitaCgiUrlToDatUrl(const Url: string): string;
  function ConvRes(const Body, Bbs, Key,
    ReadCGI, ParamBBS, ParamKey, ParamStart, ParamTo, ParamNofirst, ParamTrue : string): string;
  function NichReadCgiUrlNewToOld(const Url: string): string;
  function NichDatUrlToBoardUrl(const Url: string): string;
  function  TrimTab(const S: string): string;
  function  CountInTab(const S: string): integer;
  function  CountTab(const S: string): integer;
  function  RectVertCenter(ARect: TRect; TextHeight: integer): integer;
  function  KanToNum(const s: string): string;
  procedure HzbExtractIcon(const Path: string; var Icon: TIcon);
  function  CopyFileEx(FromFile, ToFile : string; ShowOverWriteDialog: boolean = True): boolean;
  function  MoveFileEx(FromFile, ToFile : string; ShowOverWriteDialog: boolean = True): boolean;
  function  DeleteFileEx(FromFile : string; ShowWarning: boolean = True;
    DelToTrash: boolean = True): boolean;
  procedure ClearMenuItem(vMenuItem: TMenuItem);
  function  HanToZen(const s: string): string;

  function JConv(const CharSet: TCharSet; const S: string): string;
  function JConvOut(const CharSet: TCharSet; const S: string): string;
  procedure TrimNull(var S: string);
  function Unzip(ms: TMemoryStream): string;
  function StrMatch(const ParamStr, TargetStr: string): boolean;
  function ExpandRelativeLink(const BaseUrl, Value: string): string;
  function ReplaceRelativeUrl(const ABody, ABoardID, ADatNo, AReadCGIPath: string): string;
  function DateBetweenStr(DateFrom, DateTo : TDateTime): string;  //12
  function UrlToFileName(const Url: string): string; //14
  function Extract(const Text, StartStr, EndStr: string): string; //14
  function Pickup(Text, Chr: string): string;
  function CharsetToText(const Charset: TCharset): string;  //18
  function TextToCharset(const s: string): TCharSet;        //18


implementation

uses
  jconvert, gzip, Utf8tosjis;

{///////////////////////////////////////////////////////////////////////////////
  from monaCommonFunc/turbo type D
///////////////////////////////////////////////////////////////////////////////}
function GetFileDate(FileName: String): TDateTime;
var
  FileHnd     : integer;
  intDosDate  : integer;
  datFileDate : TDateTime;
begin
  FileHnd := 0;
  Try
    { t@C̃nh擾 }
    FileHnd :=  FileOpen(FileName,fmOpenRead);
    { t@C̃^CX^v擾 }
    intDosDate  :=  FileGetDate(FileHnd);
    { ^CX^vt^ɕϊ }
    datFileDate :=  FileDateToDateTime(intDosDate);
    Result := datFileDate;
  Finally
    FileClose(FileHnd);
  end;
end;
{EG(LDM) homepage2.nifty.com\boheme\delphi\tips\tec0070.htm}

{///////////////////////////////////////////////////////////////////////////////
  from monaCommonFunc/turbo type D
///////////////////////////////////////////////////////////////////////////////}

//P/P/P/P/P/P/P/P/P/P/P/P/P/P/P/P/P/P
{
// OFturbo type D@monazilla.org(m
^PPPPPPPPPPPPPPPP_
ăAG[i  ƌɂ񂾂
ăAG[i

RRJmR[hn: t́𒲂ׂ֐
CXEn:      Second: eb
Xgn:      True: 
            False: ł͂ȂƂ݂Ȃ
REVF   2001/03/02

ĂĂ肪  AG[i
_QQQQQQQQ  QQQQQQQ^
                  |/
                 _
             íE j
             imj
//PPPPPPPPPPPPPPPPPP }
function DateTimeNearEqual(A, B: TDateTime; Second: word): Boolean;
var
  Year1, Month1, Day1, Hour1, Min1, Sec1, MSec1: word;
  Year2, Month2, Day2, Hour2, Min2, Sec2, MSec2: word;
begin
  Result := False;
  try
    DecodeDate(A, Year1, Month1, Day1);
    DecodeDate(B, Year2, Month2, Day2);
    DecodeTime(A, Hour1, Min1, Sec1, MSec1);
    DecodeTime(B, Hour2, Min2, Sec2, MSec2);

    if (Year1<>Year2) or (Month1<>Month2) or (Day1<>Day2) then
    begin
      Exit;
    end;
    if (Hour1<>Hour2) or (Min1<>Min2) then
    begin
      Exit;
    end;

    if (Sec1-Second<=Sec2) and (Sec2<=Sec1+Second) then
    begin
      Result := True;
    end;

  except
    raise Exception.Create('t^IJVC悤ł');
    Result := false;
  end;
end;

(*************************************************************************
 *TuWFNgs𕪊
 *Public
 *************************************************************************)
 //from gikoNavi
procedure DivideNichSubject(subject: string; var FileName: string; var Title: string; var Count: integer);
type
  TNichDivideType = (dtNoValue, dtTeri, dtTako, dtOther, dtNew);
  //  dtTeri  ....  DAT<>^Cg<JEg>
  //  dtTako  ....  DAT,^CgiJEgj
  //  dtOther ....  DAT,^Cg(JEg)
  //  dtNew ......  DAT<>^Cg(JEg)
var
	i: integer;
	ws: WideString;
	Rec: TStrTokRec;
  DivideType : TNichDivideType;
begin
	Count := 0;
  DivideType  :=  dtNoValue;

	if Copy(subject, Length(subject), 1) = '>' then begin
    DivideType  :=  dtTeri;
		i := Pos('<>', subject);
		FileName := Copy(subject, 1, i - 1);
		Title := Copy(subject, i + 2, Length(subject));
	end else begin
		i := Pos('<>', subject);
    if  (i > 0) then  begin
      DivideType  :=  dtNew;
      FileName := Copy(subject, 1, i - 1);
      Title := Copy(subject, i + 2, Length(subject));
    end else begin
  		FileName := Trim(StrTokFirst(subject, [','], Rec));
	  	Title := Trim(StrTokNext([','], Rec));
    end;
	end;

	ws := Trim(Title);
//	ws := Copy(ws, Length(ws) - 6, 7);

	if Copy(ws, Length(ws), 1) = ')' then begin
		//(nn)̏ꍇipJbRj
    if  (DivideType = dtNoValue)  then  DivideType  :=  dtOther;
		for i := Length(ws) - 1 downto 1 do begin
			if ws[i] = '(' then begin
				ws := Copy(ws, i + 1, Length(ws) - i - 1);
				if IsNumeric(ws) then
					Count := StrToInt(ws);
				Title := Trim(StringReplace(Title, '(' + ws + ')', '', [rfReplaceAll]));
				break;
			end;
		end;
	end else if Copy(ws, Length(ws), 1) = 'j' then begin
		//innj̏ꍇiSpJbRj
    if  (DivideType = dtNoValue)  then  DivideType  :=  dtTako;
		for i := Length(ws) - 1 downto 1 do begin
			if ws[i] = 'i' then begin
				ws := Copy(ws, i + 1, Length(ws) - i - 1);
				if IsNumeric(ws) then
					Count := StrToInt(ws);
        //takoT[o[Ή
				Title := Trim(StringReplace(Title, 'i' + ws + 'j', '', [rfReplaceAll]));
				break;
			end;
		end;
	end else begin
		//<nn>̏ꍇ
		for i := Length(ws) - 1 downto 1 do begin
			if ws[i] = '<' then begin
				ws := Copy(ws, i + 1, Length(ws) - i - 1);
				if IsNumeric(ws) then
					Count := StrToInt(ws);
				Title := Trim(StringReplace(Title, '<' + ws + '>', '', [rfReplaceAll]));
				break;
			end;
		end;
	end;
  if  (DivideType = dtTako) or (DivideType = dtOther) then  begin
    Title := StringReplace(Title, 'M',',',[rfReplaceAll]);
  end;
end;

(*************************************************************************
 *񂩂g[N̐؂oij
 *Public iFDelphĩpNj
 *************************************************************************)
 // from  gikoNavi
function StrTokFirst(const s:string; const sep: TStrTokSeparator; var Rec: TStrTokRec): string;
begin
	Rec.Str := s;
	Rec.Pos := 1;
	Result := StrTokNext(sep, Rec);
end;

(*************************************************************************
 *񂩂g[N̐؂o
 *Public iFDelphĩpNj
 *************************************************************************)
 // from  gikoNavi
function StrTokNext(const sep: TStrTokSeparator; var Rec: TStrTokRec): string;
var
	Len, I: Integer;
begin
	with Rec do	begin
		Len := Length(Str);
		Result := '';
		if Len >= Pos then begin
			while (Pos <= Len) and (Str[Pos] in sep) do begin
			 Inc(Pos);
			end;
			I := Pos;
			while (Pos<= Len) and not (Str[Pos] in sep) do begin
				if IsDBCSLeadByte(Byte(Str[Pos])) then begin
					Inc(Pos);
				end;
				Inc(Pos);
			end;
			Result := Copy(Str, I, Pos - I);
			while (Pos <= Len) and (Str[Pos] in sep) do begin// ͂D
				Inc(Pos);
			end;
		end;
	end;
end;

function NichCgiUrlToDatUrl(const Url: string): string;
var
  S, BBS , Key, AUrl : string;
begin
  AUrl  :=  NichReadCgiUrlNewToOld(Url);
  {http://teri.2ch.net/test/read.cgi?bbs=accuse&key=991408877&ls=50}
  {http://teri.2ch.net/accuse/dat/991408877.dat}
  S       :=  MonaUtils.ExtractHostName(AUrl);
  BBS     :=  ChooseValue(AUrl, 'bbs');
  Key     :=  ChooseValue(AUrl, 'key');
  Result  :=  'http://' + S + '/' + BBS + '/dat/' + Key + '.dat';
end;

function GetShortTitle(const LongName: string; ALength: integer): string;
const
  ERASECHAR : array [1..17] of string  =
    ('','','','','','Q','','','','',
     '','','','','y','z','');
var
  Chr : array [0..255]  of  char;
  S : string;
  i : integer;
begin
  S :=  StringReplace(LongName, '&', '&&', [rfReplaceAll]);
  S :=  StringReplace(S, '', '', [rfReplaceAll]);
  for i :=  Low(ERASECHAR)  to  High(ERASECHAR) do  begin
    S :=  StringReplace(S, ERASECHAR[i], '', [rfReplaceAll]);
  end;
  if  (Length(S) <= ALength) then  begin
    Result  :=  S;
  end else begin
    Windows.LCMapString(
        GetUserDefaultLCID(),
        LCMAP_HALFWIDTH,
        PChar(S),
        Length(S) + 1,
        chr,
        Sizeof(chr)
        );
    S :=  Chr;
    S :=  Copy(S,1,ALength);
    while true  do  begin
      if  (ByteType(S, Length(S)) = mbLeadByte )  then  begin
        S :=  Copy(S, 1, Length(S) - 1);
      end else begin
        Break;
      end;
    end;
    Result  :=  S;
  end;
end;

{
function PickupKakoUrl(const Content, DatNo: string): string;
var
  n : integer;
  s : string;
  Parser  : TMonaHtmlParser;
begin
  Result  :=  '';
  Parser  :=  TMonaHtmlParser.Create(Content);
  while Parser.GetToken <> htNone do  begin
    if  (Parser.TokenType = htTag)  then  begin
      if  (AnsiPos('A', AnsiUpperCase(Parser.Token)) = 1) then  begin
        if  (AnsiPos(DatNo, Parser.Token) > 0)  then  begin
          n :=  AnsiPos('HREF', AnsiUpperCase(Parser.Token));
          s :=  Copy(Parser.Token, n + 1, Length(Parser.Token));
          n :=  AnsiPos('"', s);
          s :=  Copy(s, n + 1, Length(Parser.Token));
          n :=  AnsiPos('"', s);
          s :=  Copy(s, 1, n - 1);

          //n :=  AnsiPos('.', s);
          //s :=  Copy(s, 1, n - 1);
          s := ChangeFileExt(s, '.dat');

          Result  :=  s;
          Break;
        end;
      end;
    end;
  end;
end;
}

procedure DivideShitaSubject(subject: string; var FileName: string; var Title: string; var Count: integer);
begin
  FileName  :=  ChooseString(subject, '<>', 0);
  Title     :=  ChooseString(subject, '<>', 1);
  Count     :=  StrToIntDef(ChooseString(subject, '<>', 2), 0);
end;

function ShitaCgiUrlToDatUrl(const Url: string): string;
var
  S, BBS , Key : string;
begin
  {http://teri.2ch.net/test/read.cgi?bbs=accuse&key=991408877&ls=50}
  { http://teri.2ch.net/accuse/dat/991408877.dat}
  //http://www.shitaraba.com/bbs/help/dat/995966148_1.dat
  S       :=  MonaUtils.ExtractHostName(Url);
  BBS     :=  ChooseValue(Url, 'bbs');
  Key     :=  ChooseValue(Url, 'key');
  Result  :=  'http://' + S + '/bbs/' + BBS + '/dat/' + Key + '.dat';
end;

//
//  邢R[hȂ̂ŌȂŁI
//
function ConvRes(const Body, Bbs, Key,
  ReadCGI, ParamBBS, ParamKey, ParamStart, ParamTo, ParamNoFirst, ParamTrue : string): string;
type
  PIndex = ^TIndex;
  TIndex = record
    FIndexFrom  : integer;
    FIndexTo    : integer;
    FNo         : string;
  end;
const
  GT  = '&gt;';
  SN  = '0123456789-';
  ZN  = 'OPQRSTUVWX|';
var
  i : integer;
  s,r : string;
  b : TMbcsByteType;
  sw: boolean;
  sp: integer;
  No: string;
  sx: string;
  List: TList;
  oc  : string;
  st, et: string;
  chk : boolean;
  al : boolean;
  sReadCGI: string;
  procedure Add(IndexFrom, IndexTo: integer; const No: string);
  var
    FIndex : PIndex;
  begin
    New(FIndex);
    FIndex.FIndexFrom  := IndexFrom;
    FIndex.FIndexTo    := IndexTo;
    FIndex.FNo         := No;
    List.Add(FIndex);
  end;
begin
  { v1.0 b2 - 03 }
  s   :=  Body;
  r   :=  Body;
  i   :=  1;
  sw  :=  False;
  No  :=  '';
  List:=  TList.Create;
  oc  :=  '';
  sp  :=  0;
  chk :=  False;
  al  :=  False;
  while true  do  begin
    b :=  ByteType(s, i);
    case  b of
      mbSingleByte  : begin
        if  (not sw) and (Copy(s,i,8) = GT + GT) then  begin
          if  (AnsiPos('<A HREF', AnsiUpperCase(oc)) = 0) then  begin
            sw  :=  True;
            sp  :=  i;
            i :=  i + 7;
            oc:='';
            chk :=  True;
          end;
        end else
        if  (not sw) and (Copy(s,i,8) = GT + GT) then  begin
          if  (AnsiPos('<A HREF', AnsiUpperCase(oc)) = 1) then  begin
            i :=  i + 7;
            oc:='';
            chk :=  True;
          end;
        end else
        if  (not sw) and (Copy(s,i,4) = GT) then  begin
          if  (AnsiPos('<A HREF', AnsiUpperCase(oc)) = 0) then  begin
            sw  :=  True;
            sp  :=  i;
            i :=  i + 3;
            oc:='';
            chk :=  True;
          end;
        end else
        if  ((not sw) and (Copy(s,i,1) = ',')) or
            ((not sw) and (Copy(s,i,1) = '=')) then  begin
          if  ((not Chk) and (AnsiLowerCase(oc) = '</a>')) or
              ((Chk) and  (oc = '')) or
              ((not Chk) and (al)) then
          begin
            sw  :=  True;
            sp  :=  i;
            //i :=  i + 1;
            oc:='';
          end;
        end else
        if  (sw) then begin
          sx  :=  Copy(s,i,1);
          if  (AnsiPos(sx, SN) > 0)  then  begin
            No  :=  No  + sx;
          end else begin
            if  (No <> '') and (No <> '-')   then  begin
              Add(sp, i, No);
              al := True;
            end;
            sw  :=  False;
            //
            i := i - 1;
            //
            No  := '';
            oc:='';
            //chk :=  False;
          end;
        end else begin
          if  Copy(s,i,1) = '<' then  oc  :=  '';
          oc  :=  oc + Copy(s,i,1);
          chk :=  False;
          al  :=  False;
        end;
      end;
      mbLeadByte  : begin
        if  (not sw) and (Copy(s,i,4) = '') then  begin
          sw  :=  True;
          sp  :=  i;
          i :=  i + 3;
          chk :=  True;
        end else
        if  (not sw) and ((Copy(s,i,2) = '') or (Copy(s,i,2) = 't')) then  begin
          sw  :=  True;
          sp  :=  i;
          i :=  i + 1;
          chk :=  True;
        end else
        if  (sw) then begin
          sx  :=  Copy(s,i,2);
          if  (AnsiPos(sx, ZN) > 0)  then  begin
            No  :=  No  + ZenToHan(sx);
          end else begin
            if  (No <> '') and (No <> '-')  and (No <> '|') then  begin
              Add(sp, i, No);
            end;
            sw  :=  False;
            i := i - 1;
            No  :=  '';
          end;
        end else begin
          oc  :=  '';
          chk :=  False;
        end;
        al  :=  False;
      end;
    end;
    inc(i);
    if  (i > Length(Body))  then  begin
      if  (sw)  then  begin
        if  (No <> '')  then  Add(sp, i, No);
      end;
      Break;
    end;
  end;

  sReadCGI  :=  ReadCGI;
  if  (AnsiPos('?', sReadCGI)> 0) then  sReadCGI  :=  Copy(sReadCGI, 1, AnsiPos('?', sReadCGI) - 1);
  for i :=  List.Count - 1  downto  0 do  begin
    if  (AnsiPos('-', PIndex(List[i]).FNo) > 0) then  begin
      st  :=  ChooseString(PIndex(List[i]).FNo, '-', 0);
      et  :=  ChooseString(PIndex(List[i]).FNo, '-', 1);
    end else begin
      st  :=  PIndex(List[i]).FNo;
      et  :=  PIndex(List[i]).FNo;
    end;
    r :=  Copy(r,0, PIndex(List[i]).FIndexFrom - 1) +
          Format('<a href="%s?%s=%s&%s=%s&%s=%s&%s=%s&%s=%s" target="_blank">',
                [sReadCGI, ParamBBS, Bbs, ParamKey, Key, ParamStart, st, ParamTo, et, ParamNoFirst, ParamTrue]) +
          Copy(r,PIndex(List[i]).FIndexFrom, PIndex(List[i]).FIndexTo - PIndex(List[i]).FIndexFrom) + '</A>' +
          Copy(r,PIndex(List[i]).FIndexTo,Length(r));
    Dispose(PIndex(List[i]));
  end;
  List.Free;
  Result  :=  r;
end;

function NichReadCgiUrlNewToOld(const Url: string): string;
var
  n : integer;
  s : string;
begin
  n :=  AnsiPos('/read.cgi/', Url);
  if  (n > 0) then  begin
    // http://piza2.2ch.net/test/read.cgi/tech/1000035521/
    // http://piza2.2ch.net/test/read.cgi?bbs=tech&key=1000035521
    s := Copy(Url, n + 1, Length(Url));
    // s =  read.cgi/tech/1000035521/
    Result  :=  Copy(Url, 1, n) + 'read.cgi' +
              '?bbs=' + ChooseString(s, '/', 1) +
              '&key=' + ChooseString(s, '/', 2);
  end else begin
    Result  :=  Url;
  end;
end;

function NichDatUrlToBoardUrl(const Url: string): string;
// http://piza2.2ch.net/test/read.cgi/tech/1000035521/
begin
end;

function TrimTab(const S: string): string;
var
  i : integer;
begin
  for i :=  1 to  Length(S) do  begin
    if  (S[i] <> #9) then  begin
      Result  :=  Copy(S, i, Length(S));
      Break;
    end;
  end;
end;

function CountInTab(const S: string): integer;
var
  i : integer;
  r : integer;
begin
  r :=  0;
  for i :=  1 to  Length(S) do  begin
    if  (S[i] = #9) then  begin
      inc(r);
    end;
  end;
  Result := r;
end;

function CountTab(const S: string): integer;
var
  i : integer;
  r : integer;
begin
  r :=  0;
  for i :=  1 to  Length(S) do  begin
    if  (S[i] = #9) then  begin
      inc(r);
    end else begin
      Break;
    end;
  end;
  Result := r;
end;

function  RectVertCenter(ARect: TRect; TextHeight: integer): integer;
begin
  Result  :=  ARect.Top +
               ((ARect.Bottom - ARect.Top) - Abs(TextHeight)) div 2;
end;

function KanToNum(const s: string): string;
var
  ss : string;
begin
  ss  :=  S;
  ss  :=  StringReplace(ss, '', '0', [rfReplaceAll]);
  ss  :=  StringReplace(ss, '', '1', [rfReplaceAll]);
  ss  :=  StringReplace(ss, '', '2', [rfReplaceAll]);
  ss  :=  StringReplace(ss, 'O', '3', [rfReplaceAll]);
  ss  :=  StringReplace(ss, 'l', '4', [rfReplaceAll]);
  ss  :=  StringReplace(ss, '', '5', [rfReplaceAll]);
  ss  :=  StringReplace(ss, 'Z', '6', [rfReplaceAll]);
  ss  :=  StringReplace(ss, '', '7', [rfReplaceAll]);
  ss  :=  StringReplace(ss, '', '8', [rfReplaceAll]);
  ss  :=  StringReplace(ss, '', '9', [rfReplaceAll]);
  ss  :=  StringReplace(ss, '\', '10', [rfReplaceAll]);
  ss  :=  StringReplace(ss, '', '1', [rfReplaceAll]);
  ss  :=  StringReplace(ss, '', '2', [rfReplaceAll]);
  ss  :=  StringReplace(ss, 'Q', '3', [rfReplaceAll]);
  ss  :=  StringReplace(ss, '', '5', [rfReplaceAll]);
  ss  :=  StringReplace(ss, 'T', '1', [rfReplaceAll]);
  ss  :=  StringReplace(ss, 'U', '2', [rfReplaceAll]);
  ss  :=  StringReplace(ss, 'V', '3', [rfReplaceAll]);
  ss  :=  StringReplace(ss, 'W', '4', [rfReplaceAll]);
  ss  :=  StringReplace(ss, 'X', '5', [rfReplaceAll]);
  ss  :=  StringReplace(ss, 'Y', '6', [rfReplaceAll]);
  ss  :=  StringReplace(ss, 'Z', '7', [rfReplaceAll]);
  ss  :=  StringReplace(ss, '[', '8', [rfReplaceAll]);
  ss  :=  StringReplace(ss, '\', '9', [rfReplaceAll]);
  ss  :=  StringReplace(ss, ']', '10', [rfReplaceAll]);
  ss  :=  StringReplace(ss, '@', '1', [rfReplaceAll]);
  ss  :=  StringReplace(ss, 'A', '2', [rfReplaceAll]);
  ss  :=  StringReplace(ss, 'B', '3', [rfReplaceAll]);
  ss  :=  StringReplace(ss, 'C', '4', [rfReplaceAll]);
  ss  :=  StringReplace(ss, 'D', '5', [rfReplaceAll]);
  ss  :=  StringReplace(ss, 'E', '6', [rfReplaceAll]);
  ss  :=  StringReplace(ss, 'F', '7', [rfReplaceAll]);
  ss  :=  StringReplace(ss, 'G', '8', [rfReplaceAll]);
  ss  :=  StringReplace(ss, 'H', '9', [rfReplaceAll]);
  ss  :=  StringReplace(ss, 'I', '10', [rfReplaceAll]);
  Result :=  ss;
end;

procedure HzbExtractIcon(const Path: string; var Icon: TIcon);
begin
  Icon  :=  TIcon.Create;
  Icon.Handle  :=  ExtractIcon(hInstance, PChar(Path), 0);
end;

function FileOperatoin(Operation: UINT; FromFile, ToFile : string;
  ShowOverWriteDialog: boolean = True; DelToTrash: boolean = True): boolean;
var
  pFileOpe  : SHFILEOPSTRUCT;
  r         : integer;
begin
  FromFile        :=  FromFile  + #0;
  ToFile          :=  ToFile    + #0;
  with  pFileOpe  do  begin
    wnd           :=  GetDesktopWindow;
    wFunc         :=  Operation;
    pFrom         :=  PChar(FromFile);
    pTo           :=  PChar(ToFile);
    if  Operation =   FO_DELETE then  begin
      if  ShowOverWriteDialog then  begin
        fFlags      :=  FOF_FILESONLY;
      end else begin
        fFlags      :=  FOF_FILESONLY or FOF_NOCONFIRMATION;
      end;
      if  DelToTrash  then  fFlags  :=  fFlags or FOF_ALLOWUNDO;
    end else begin
      if  ShowOverWriteDialog then  begin
        fFlags      :=  FOF_ALLOWUNDO;
      end else begin
        fFlags      :=  FOF_ALLOWUNDO or  FOF_NOCONFIRMATION;
      end;
    end;
  end;
  r               :=  SHFileOperation(pFileOpe);
  if  pFileOpe.fAnyOperationsAborted  = LONGBOOL(1) then  begin
    Result        :=  False;
  end else begin
    Result        :=  (r  = 0);
  end;
end;

function CopyFileEx(FromFile, ToFile : string; ShowOverWriteDialog: boolean = True): boolean;
begin
  Result  :=  FileOperatoin(FO_COPY, FromFile, ToFile, ShowOverWriteDialog);
end;

function MoveFileEx(FromFile, ToFile : string; ShowOverWriteDialog: boolean = True): boolean;
begin
  Result  :=  FileOperatoin(FO_MOVE, FromFile, ToFile, ShowOverWriteDialog);
end;

function DeleteFileEx(FromFile : string; ShowWarning: boolean = True; DelToTrash: boolean = True): boolean;
begin
  if  (AnsiPos('*', FromFile) > 0) or (IsDelimiter('\', FromFile, 0))  then  begin
    Result  :=  FileOperatoin(FO_DELETE, FromFile, '', ShowWarning, DelToTrash);
  end else begin
    if  (FileExists(FromFile))  then  begin
      Result  :=  FileOperatoin(FO_DELETE, FromFile, '', ShowWarning, DelToTrash);
    end;
  end;
end;

procedure ClearMenuItem(vMenuItem: TMenuItem);
(*
 * Tv
 * 
 *)
var
  i: Integer;
  procedure ClearMenuItemSub(vParent, vMenuItem: TMenuItem);
  var
    i: Integer;
    Item: TMenuItem;
  begin
    for i := 0 to vMenuItem.Count - 1 do
      ClearMenuItemSub(vMenuItem, vMenuItem[0]);

    if (vParent <> nil) then begin
      Item := vParent[0];
      vParent.Delete(0);

      Item.Free;
    end;
  end;
begin
  for i := 0 to vMenuItem.Count - 1 do
    ClearMenuItemSub(vMenuItem, vMenuItem[0]);
end;

function HanToZen(const s: string): string;
var
  Chr : array [0..255]  of  char;
begin
  Windows.LCMapString(
     GetUserDefaultLCID(),
     LCMAP_FULLWIDTH,
     PChar(s),
     Length(s) + 1,
     chr,
     Sizeof(chr)
     );
  Result :=  Chr;
end;


//
//  ϊ
//
function JConv(const CharSet: TCharSet; const S: string): string;
begin
  if  (CharSet = csSJIS)  then  begin
    if  (AnsiPos(#13#10, S) = 0)  then  begin
      Result  :=  S;
    end else begin
      Result  :=  StringReplace(S, #10, #13#10, [rfReplaceAll]);
    end;
  end else
  if  (CharSet = csEUC)  then  begin
    Result  :=  jconvert.euc2sjis(S);
  end else
  //14 begin
  if  (CharSet = csUTF8)  then  begin
    Result  :=  Utf8tosjis.UTFtoSJIS(S);
  end;
  //14 end
end;

//
//  ϊ
//
function JConvOut(const CharSet: TCharSet; const S: string): string;
begin
  if  (CharSet = csSJIS)  then  begin
    Result  :=  jconvert.ConvertJCode(S, SJIS_OUT);
  end else begin
    Result  :=  jconvert.ConvertJCode(S, EUC_OUT);
  end;
end;

procedure TrimNull(var S: string);
var
  p, p_end : PChar;
begin
  p := PChar(S);
  p_end := PChar(S) + Length(S);
  while p < p_end do begin
    if p^ = #0 then begin
      p^ := '*';
    end;
    Inc(p);
  end;
end;

function Unzip(ms: TMemoryStream): string;
var
  ch : array [0..255] of char;
  gs : TGzipDecompressStream;
  ss : TStringStream;
  bt : integer;
  p, p_end : PChar;
  sx : string;
begin
  ss  :=  TStringStream.Create('');
  gs  :=  TGzipDecompressStream.Create(ss);
  ms.Position :=  0;
  try
    while (ms.Position < ms.Size)  do  begin
      bt  :=  ms.Read(ch, Sizeof(ch));
      gs.Write(ch, bt);
    end;
    ss.Position :=  0;
    sx  :=  ss.ReadString(ss.Size);
  except
    on  E:EGzipInvalidFileError do  begin
      ms.Position :=  0;
      ms.SaveToStream(ss);
      sx  :=  ss.DataString;
    end
    else
    begin
      raise;
    end;
  end;

  p := PChar(sx);
  p_end := PChar(sx) + Length(sx);
  while p < p_end do begin
    if p^ = #0 then begin
      p^ := '*';
    end;
    Inc(p);
  end;
  
  ss.Free;
  gs.Free;

  Result  :=  sx;
end;

function StrMatch(const ParamStr, TargetStr: string): boolean;
var
  s1, s2 : string;
begin
  if  (AnsiPos('*', ParamStr) > 0)  then  begin
    s1  :=  Copy(ParamStr, 1, AnsiPos('*', ParamStr) - 1);
    s2  :=  Copy(ParamStr, AnsiPos('*', ParamStr) + 1, Length(ParamStr));  
    Result  :=  (Copy(TargetStr,1, Length(s1)) = s1) and
                (Copy(TargetStr, Length(TargetStr) - Length(s2) + 1, Length(TargetStr)) = s2);
  end else begin
    Result  :=  (ParamStr = TargetStr);
  end;
end;


function ExpandRelativeLink(const BaseUrl, Value: string): string;
var
  Org, s, r : string;
  x, y, z, t, a : string;
  p, i : integer;
  base: string;
begin
  r   :=  '';
  Org :=  Value;
  while true  do  begin
    p :=  AnsiPos('<a', AnsiLowerCase(Org));
    if  (p > 0) then  begin
      //擪<A ܂ł --> r
      s :=  Copy(Org, 1, p - 1);
      r :=  r + s;
      //<A  > ܂ł --> s

      // s = "<A xxxx xxxxxx>"
      //t :=  Copy(Org, p, Length(org));
      s :=  Copy(Org, p, Length(org));
      i :=  AnsiPos('>', s);
      if  (i = 0) then  Break;
      t :=  Copy(s, i + 1, Length(s));
      s :=  Copy(S, 1, i);

      if  (AnsiPos('href', AnsiLowerCase(s)) > 0) then  begin
        //TARGET=
        p :=  AnsiPos('HREF=', AnsiUpperCase(s));
        if  (p > 0) then  begin
          x :=  Copy(s, 1, p - 1);  //HREF܂
          y :=  Copy(s, p, Length(s));  //HREFȍ~
          i :=  AnsiPos(' ', y);
          if  (i > 0) then  begin
            y :=  Copy(y, 1, i - 1);
          end;
          i :=  AnsiPos('>', y);
          if  (i > 0) then  begin
            y :=  Copy(y, 1, i - 1);
          end;

          a :=  Copy(y, AnsiPos('HREF=', AnsiUpperCase(y)) + 5, Length(y));
          a :=  ExtractQuotedStr(a, '"');

          if  (a <> '') then  begin
            if  (a[1] <>  '.')  then  begin
              Result  :=  Value;
              Exit;
            end;
          end else begin
            Result  :=  Value;
            Exit;
          end;

          //HREF ̂ --> y
          z :=  Copy(s, Length(x) + Length(y) + 1, Length(s)); //HREF

          //  x = '<a '

          //  y  = 'href="./xxx/aaa/bbb.htm"

          //  z  = 'target="_blank">'

          //  a  = './xxx/aaa/bbb.htm'

          if  (BaseURL[Length(BaseURL)] <> '/')  then  begin
            base  :=  ExtractUrlPath(BaseURL);
          end else begin
            base  :=  BaseURL;
          end;

          s :=  MargeUrl(base, a);

          s :=  x + 'href="' +  s  +  '"' + z;

          r :=  r + s;
          //org :=  Copy(org, AnsiPos('>', Org) + 1, Length(org));
          Org := t;
        {
        end else begin
          //<A xxxxxxx>
          s :=  Copy(s, 1, Length(S) - 1) + ' TARGET="_blank">';
          r :=  r + s;
          //org :=  Copy(org, AnsiPos('>', Org) + 1, Length(org));
          Org := t;
        }
        end;


      end else begin
        r :=  r + s;
        org :=  t; //Copy(org, Length(t) + 1, Length(org));
      end;

    end else begin;
      r :=  r + Org;
      Break;
    end;
  end;
  Result  :=  r;
end;

function ReplaceRelativeUrl(const ABody, ABoardID, ADatNo, AReadCGIPath: string): string;
var
  s: string;
begin
  s :=  ABody;
  if  (AnsiPos('<a href="../test/read.cgi/',s) > 0) then  begin
    s :=  StringReplace(s,
            '<a href="../test/read.cgi/' + ABoardID + '/' + ADatNo + '/',
            '<a href="' + AReadCGIPath,
            [rfIgnoreCase, rfReplaceAll]);
  end;
  Result  :=  s;
end;
{
function ShowMessage(AText, ACaption: string;
  AMsgType: TMsgDlgType; Buttons: TMsgDlgButtons): Integer;
begin
  MessageBoxEx(0, PChar(AText), PChar(ACaption), MB_OK, MB_ICONQUESTION);
end;
}



//12
function DateBetweenStr(DateFrom, DateTo : TDateTime): string;
var
  n: integer;
  s, hh, nn, ss: string;
begin
  n   :=  DaysBetween(DateFrom, DateTo);
  hh  :=  FormatDateTime('h', (DateTo - DateFrom));
  nn  :=  FormatDateTime('n', (DateTo - DateFrom));
  ss  :=  FormatDateTime('s', (DateTo - DateFrom));
  s   :=  '';
  if  (n > 0) then  begin
    s :=  IntToStr(n) + ' '
  end;
  if  (StrToIntDef(hh,0) <> 0)  then
    s :=  s + hh + ' ';
  if  (StrToIntDef(nn,0) <> 0)  then
    s :=  s + nn + ' ';
  if  (StrToIntDef(ss,0) <> 0)  then  begin
    s :=  s + ss + 'b ';
  end;
  if  (s = '') then begin
    s :=  '0b ';
  end;
  Result  :=  Trim(s);
end;

function UrlToFileName(const Url: string): string;
var
  s: string;
  i: integer;
begin
  if  (AnsiPos('://', Url) > 0) then  begin
    s :=  Copy(Url, AnsiPos('://', Url) + 3, Length(Url));
  end else begin
    s :=  Url;
  end;
  if  (s = '')  then  begin
    s :=  'index.html';
  end;
  if  (s[Length(s)] = '/')  then  begin
    s :=  s + 'index.html';
  end;
  s :=  StringReplace(s, '/', '_', [rfReplaceAll]);
  s :=  StringReplace(s, '\', '_', [rfReplaceAll]);
  s :=  StringReplace(s, '?', '_', [rfReplaceAll]);
  s :=  StringReplace(s, '&', '_', [rfReplaceAll]);
  s :=  StringReplace(s, ':', '_', [rfReplaceAll]);
  s :=  StringReplace(s, ';', '_', [rfReplaceAll]);
  s :=  StringReplace(s, '*', '_', [rfReplaceAll]);
  s :=  StringReplace(s, '"', '_', [rfReplaceAll]);
  s :=  StringReplace(s, '<', '_', [rfReplaceAll]);
  s :=  StringReplace(s, '>', '_', [rfReplaceAll]);
  s :=  StringReplace(s, '|', '_', [rfReplaceAll]);
  s :=  StringReplace(s, ',', '_', [rfReplaceAll]);
  for i :=  Length(s) - 8 downto  1 do  begin
    if  (s[i] = '.')  then  s[i]  :=  '_';
  end;
  Result  :=  s;
end;

function Extract(const Text, StartStr, EndStr: string): string;
var
  s: string;
begin
  s   :=  Copy(Text, AnsiPos(StartStr, Text) + Length(StartStr), Length(Text));
  s   :=  Copy(s, 1, AnsiPos(EndStr, s) - 1);
  Result :=  s;
end;

function Pickup(Text, Chr: string): string;
var
  i: integer;
  r: string;
begin
  r :=  '';
  for i :=  Length(Text) - Length(chr) + 1  downto  0 do  begin
    if  (Copy(Text, i, Length(chr)) = chr) then  begin
      r  :=  Copy(Text, 1, i - 1);
      break;
    end;
  end;
  Result  :=  r;
end;


//18
function CharsetToText(const Charset: TCharset): string;
begin
  case  Charset of
    csSJIS: Result  :=  'SJIS';
    csEUC : Result  :=  'EUC';
    csUTF8: Result  :=  'UTF8';
  else
    Result  :=  '';
  end;
end;

//18
function TextToCharset(const s: string): TCharSet;
begin
  if  (AnsiUpperCase(s) = 'SJIS') then  begin
    Result  :=  csSJIS;
  end else
  if  (AnsiUpperCase(s) = 'EUC') then  begin
    Result  :=  csEUC;
  end else
  if  (AnsiUpperCase(s) = 'UTF8') then  begin
    Result  :=  csUTF8;
  end else begin
    Result  :=  csSJIS;
  end;
end;

end.
